unit Bmpsizer;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, CentrDlg, SetGraph;

type
  TBmpSizeDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    BmpSizeBox: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    TheBmpWidth: TSpinEdit;
    Label1: TLabel;
    TheBmpHeight: TSpinEdit;
    ColorDepthGroup: TGroupBox;
    EColorDepthCombo: TComboBox;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function GetPictureSizeDlg(BmpAttribsObj : TSettingBmpAttribsObj): boolean;

implementation

{$R *.DFM}

{---------------------------------------------------------------------}

function GetPictureSizeDlg(BmpAttribsObj : TSettingBmpAttribsObj): boolean;
var
  BmpSizeDlg : TBmpSizeDlg;
  TmpPixFormat : TPixelFormat;
begin {function GetPictureSizeDlg}
  Result := false;
  BmpSizeDlg := TBmpSizeDlg.Create(Application);
  try
    SetDlgDefaultPos(BmpSizeDlg, nil);
    BmpSizeDlg.TheBmpHeight.Value := BmpAttribsObj.BmpHeight;
    BmpSizeDlg.TheBmpWidth.Value := BmpAttribsObj.BmpWidth;
    case BmpAttribsObj.BmpColorDepth of
      pf4bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 0;
      pf8bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 1;
      pf15bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 2;
      pf16bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 3;
      pf24bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 4;
      pf32bit: BmpSizeDlg.EColorDepthCombo.ItemIndex := 5;
      else BmpSizeDlg.EColorDepthCombo.ItemIndex := -1;
    end; {case}
    if BmpSizeDlg.ShowModal = IDOK then
      begin
        Result := True;
        case BmpSizeDlg.EColorDepthCombo.ItemIndex of
          0: TmpPixFormat := pf4bit;
          1: TmpPixFormat := pf8bit;
          2: TmpPixFormat := pf15bit;
          3: TmpPixFormat := pf16bit;
          4: TmpPixFormat := pf24bit;
          5: TmpPixFormat := pf32bit;
          else TmpPixFormat := BmpAttribsObj.BmpColorDepth;
        end; {case}
        if ((BmpAttribsObj.BmpHeight = BmpSizeDlg.TheBmpHeight.Value) and
            (BmpAttribsObj.BmpWidth = BmpSizeDlg.TheBmpWidth.Value) and
            (BmpAttribsObj.BmpColorDepth = TmpPixFormat)) then
          Result := false
        else
          begin
            if (BmpAttribsObj.BmpHeight <> BmpSizeDlg.TheBmpHeight.Value) or
               (BmpAttribsObj.BmpWidth <> BmpSizeDlg.TheBmpWidth.Value) then
              begin
                BmpAttribsObj.DidWidthHeightChange := true;
                BmpAttribsObj.BmpHeight := BmpSizeDlg.TheBmpHeight.Value;
                BmpAttribsObj.BmpWidth := BmpSizeDlg.TheBmpWidth.Value;
              end; {if}
            if BmpAttribsObj.BmpColorDepth <> TmpPixFormat then
              begin
                BmpAttribsObj.DidColorDepthChange := true;
                BmpAttribsObj.BmpColorDepth := TmpPixFormat;
              end; {if}
          end; {else}
      end { if Result = true then}
  finally
    BmpSizeDlg.Free;
  end; {try..finally}
end; {function GetPictureSizeDlg}

{---------------------------------------------------------------------}

procedure TBmpSizeDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
  FormKeyPressSpinEditClose(Self, Key);
end;

{---------------------------------------------------------------------}

end.
