unit CentrErr;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CentrDlg;

type
  TCustCenterErrorMsgDlg = class(TForm)
    OKBtn: TBitBtn;
    ErrorMsgTextLabel: TLabel;
    StopShowingErrorCheckBox: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ErrorDlgCenterShowNoWait(const Msg: string; TheCenterOnForm : TForm);

implementation

{$R *.dfm}

var
  GlobalCentrErMsgDlg: TCustCenterErrorMsgDlg = nil;
  StopShowingErrorMessages : boolean = false;

procedure ErrorDlgCenterShowNoWait(const Msg: string; TheCenterOnForm : TForm);
{This function displays an error dialog and returns immediately,
   it does not wait for the dialog box to close.}
begin {procedure ErrorDlgCenterShowNoWait}
  try
    try
      if (not Assigned(GlobalCentrErMsgDlg)) and (not StopShowingErrorMessages) then
        begin
          GlobalCentrErMsgDlg := TCustCenterErrorMsgDlg.Create(Application);
          GlobalCentrErMsgDlg.ErrorMsgTextLabel.Caption := Msg;
          SetDlgDefaultPos(GlobalCentrErMsgDlg, TheCenterOnForm);
          GlobalCentrErMsgDlg.Show;
        end; {if}
    except
      GlobalCentrErMsgDlg.Free;
      GlobalCentrErMsgDlg := nil;
    end;
  except //stop all exceptions
  end;
end; {procedure ErrorDlgCenterShowNoWait}

procedure TCustCenterErrorMsgDlg.OKBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TCustCenterErrorMsgDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  GlobalCentrErMsgDlg := nil;
  StopShowingErrorMessages := StopShowingErrorCheckBox.Checked;
  Action := caFree;
end;

end.
