unit Clsample;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, ExtCtrls;

type
  TColorSample = class(TPaintBox)
  //used to be declared as; TColorSample = class(TgraphicControl)
  private
    { Private declarations }
    FColorValue : TColor;
    procedure SetColorValue(Value : TColor);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    property ColorValue : TColor read FColorValue
                           write SetColorValue;
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('MathGV', [TColorSample]);
end;

{---------------------------------------------------------------------}

constructor TColorSample.Create(AOwner: TComponent);
begin {constructor TColorSample.Create}
  inherited Create(AOwner);
  FColorValue := clwhite;
end; {constructor TColorSample.Create}

{---------------------------------------------------------------------}

procedure TColorSample.SetColorValue(Value : TColor);
begin {procedure TColorSample.SetColorValue}
  if FColorValue <> Value then
    begin
      FColorValue := Value;
      Invalidate;
    end; {if}
end; {procedure TColorSample.SetColorValue}

{---------------------------------------------------------------------}

procedure TColorSample.paint;
begin {procedure TColorSample.paint;}
  canvas.brush.color := FColorValue;
  Canvas.Rectangle(0,0,Width,Height);
end; {procedure TColorSample.paint;}

{---------------------------------------------------------------------}

end.
