unit ComnDlgs;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  Forms, Graphics, Dialogs, CentrDlg;

function ShowComnColorDlg(var CurrColor : TColor; TheCenterOnForm : TForm) : boolean;
function ReturnNewColorComnDlg(CurrColor : TColor; TheCenterOnForm : TForm) : TColor;
function ShowComnFontDlg(CurrFont : TFont; TheCenterOnForm : TForm) : boolean;

implementation

uses
  fsmain;

{---------------------------------------------------------------------}

function ShowComnColorDlg(var CurrColor : TColor; TheCenterOnForm : TForm) : boolean;
begin {function ShowComnColorDlg}
  Result := false;
  if Assigned(MainForm) then
  if Assigned(MainForm.ColorDialog1) then
    begin
      try
        MainForm.FCenterColorDlgOnForm := TheCenterOnForm;
        MainForm.ColorDialog1.Color := CurrColor;
        if MainForm.ColorDialog1.Execute then
          begin
            CurrColor := MainForm.ColorDialog1.Color;
            Result := true;
          end; {if}
      except
        Result := false;
      end; {try..except}
    end; {if}
end; {function ShowComnColorDlg}

{---------------------------------------------------------------------}

function ReturnNewColorComnDlg(CurrColor : TColor; TheCenterOnForm : TForm) : TColor;
begin {function ReturnNewColorComnDlg}
  Result := CurrColor;
  ShowComnColorDlg(Result, TheCenterOnForm);
end; {function ReturnNewColorComnDlg}

function ShowComnFontDlg(CurrFont : TFont; TheCenterOnForm : TForm) : boolean;
begin {function ShowComnFontDlg}
  Result := false;
  if Assigned(MainForm) then
  if Assigned(MainForm.FontDialog1) then
    begin
      try
        MainForm.FCenterFontDlgOnForm := TheCenterOnForm;
        MainForm.FontDialog1.Font.Assign(CurrFont);
        if MainForm.FontDialog1.Execute then
          begin
            CurrFont.Assign(MainForm.FontDialog1.Font);
            Result := true;
          end; {if}
      except
        Result := false;
      end; {try..except}
    end; {if}
end; {function ShowComnFontDlg}

{---------------------------------------------------------------------}

end.
