.386
.MODEL USE16 large, PASCAL
.CODE

; Fast Graph Source Code Unit.                                   
; Copyright (c) May 25, 1996 Greg VanMullem, All Rights Reserved.

;---------------------------------------------------------------------

;type
;  PPlotRec = ^TPlotRec;
;  TPlotRec = record
;    XPlot : longint;
;    YPlot : longint;
;    Z : TFixedPoint;
;  end;
;
;  PPointRec = ^TPointRec;
;  TPointRec = record
;    X,
;    Y,
;    Z : TFixedPoint;
;  end;
;
;  PPixRec = ^TPixRec;
;  TPixRec = record
;    Static : TPointRec;
;    Rotate : TPlotRec;
;  end;
;
;const
;  TPixArraySize = 2730;
;  TPixPtrArraySize = 24;
;  MaxPixElements = 65520;
;
;type
;  PPixArray = ^TPixArray;
;  {Arrays start at 0 so they will be easier to access with DIV and MOD}
;  TPixArray = array[0..TPixArraySize-1] of TPixRec;
;  TPixPtrArray = array[0..TPixPtrArraySize-1] of PPixArray;
;
;  PLineRec = ^TLineRec;
;  TLineRec = record
;    MiddleZ : TFixedPoint;
;    P1,
;    P2 : PPixRec;
;    FuncNum : byte;
;  end;
;
;const
;  TLineArraySize = 5040;
;  TLinePtrArraySize = 13;
;  MaxLineElements = 65520;
;
;type
;  PLineArray = ^TLineArray;
;  {Arrays start at 0 so they will be easier to access with DIV and MOD}
;  TLineArray = array[0..TLineArraySize-1] of TLineRec;
;  TLinePtrArray = array[0..TLinePtrArraySize-1] of PLineArray;

;---------------------------------------------------------------------

LineArray    EQU DWORD PTR ss:[bp+6]
ElementCount EQU WORD PTR  ss:[bp+4]
; procedure assumes that ElementCount >= 1

AsmCalcArrayMiddleZ    PROC FAR
                       PUBLIC AsmCalcArrayMiddleZ
          mov bx, bp              ;save pascal's bp
          mov dx, ds              ;save pascal's ds
          mov bp, sp              ;get pointer into stack
          les di, LineArray
          mov cx, ElementCount
          loopTop1:
            lds si, es:[di+4]      ;ds:si := TLineRec.P1
            mov eax, ds:[si+20]    ;eax := P1^.Rotate.Z
            lds si, es:[di+8]      ;ds:si := TLineRec.P2
            add eax, ds:[si+20]    ;eax := eax + P2^.Rotate.Z
            sar eax, 1             ;eax := eax / 2
            mov es:[di], eax       ;TLineRec.MiddleZ := eax
            add di, 13             ;point to next TLineRec.MiddleZ
          loop LoopTop1
          mov ds, dx               ;Restore pascal's ds
          mov bp, bx               ;Restore pascal's bp
          retf 6                   ;parameters take 6 bytes
AsmCalcArrayMiddleZ    ENDP

;---------------------------------------------------------------------

                       END