.386
.MODEL USE16 large, PASCAL
.CODE

; Fast Graph Source Code Unit.
; Copyright (c) May 25, 1996 Greg VanMullem, All Rights Reserved.

;---------------------------------------------------------------------

;Type
;  TFixedPoint = longint;
;
;  TTrigAngles = record
;    CosRadX, CosRadY, CosRadZ,
;    SinRadX, SinRadY, SinRadZ : TFixedPoint;
;  end; {TTrigAngles}
;
;type
;  PPlotRec = ^TPlotRec;
;  TPlotRec = record
;    XPlot : longint;
;    YPlot : longint;
;    Z : TFixedPoint;
;  end;
;
;  PPointRec = ^TPointRec;
;  TPointRec = record
;    X,
;    Y,
;    Z : TFixedPoint;
;  end;
;
;  PPixRec = ^TPixRec;
;  TPixRec = record
;    Static : TPointRec;
;    Rotate : TPlotRec;
;  end;
;
;const
;  TPixArraySize = 2730;
;  TPixPtrArraySize = 24;
;  MaxPixElements = 65520;
;
;type
;  PPixArray = ^TPixArray;
;  {Arrays start at 0 so they will be easier to access with DIV and MOD}
;  TPixArray = array[0..TPixArraySize-1] of TPixRec;
;  TPixPtrArray = array[0..TPixPtrArraySize-1] of PPixArray;

;---------------------------------------------------------------------

;assumes NumRec >= 1

StaticX     EQU DWORD PTR ds:[si]
StaticY     EQU DWORD PTR ds:[si+4]
StaticZ     EQU DWORD PTR ds:[si+8]
RotateXPlot EQU DWORD PTR ds:[si+12]
RotateYPlot EQU DWORD PTR ds:[si+16]
RotateZ     EQU DWORD PTR ds:[si+20]

AsmRotateOneArray  PROC FAR PixelArray:DWORD, NumRec:WORD, \
                   ViewZoom:DWORD, HalfBmpHeight:DWORD, HalfBmpWidth:DWORD,\
                   CosRadX:DWORD, CosRadY:DWORD, CosRadZ:DWORD, \
                   SinRadX:DWORD, SinRadY:DWORD, SinRadZ:DWORD
                   PUBLIC AsmRotateOneArray
                   LOCAL NewX:DWORD, NewY:DWORD, NewZ:DWORD = LocalSpace
   sub  sp, LocalSpace  ;open stack hole for local variables
   push es
   push ds
   push di
   push si
   pushad
   ;setup variables for loop
   lds si, PixelArray    ;ds:si := PixelArray
   mov ecx, 0           ;make sure ecx is zero after NumRec is loaded
   mov cx, NumRec       ;execute loop NumRec times
   MainLoopTop:
     ;Rotate about X Axis
       ;NewX := X
       ;NewY := cos(theta)*Y - sin(theta)*Z
         ;cos(theta)*Y
           mov eax, StaticY
           imul CosRadX       ;edx:eax := cos(theta)*Y
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;sin(theta)*Z
           mov eax, StaticZ
           imul SinRadX       ;edx:eax := sin(theta)*Z
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "-"
           sub ebx, eax       ;ebx := cos(theta)*Y - sin(theta)*Z
           mov NewY, ebx      ;store NewY
       ;NewZ := sin(theta)*Y + cos(theta)*Z
         ;sin(theta)*Y
           mov eax, StaticY
           imul SinRadX       ;edx:eax := sin(theta)*Y
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;cos(theta)*Z
           mov eax, StaticZ
           imul CosRadX       ;edx:eax := cos(theta)*Z
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "+"
           add ebx, eax       ;ebx := sin(theta)*Y + cos(theta)*Z
           mov NewZ, ebx      ;store NewZ
     ;Rotate about Y Axis
       ;NewY := Y
       ;NewX := cos(theta)*X + sin(theta)*Z
         ;cos(theta)*X
           mov eax, StaticX
           imul CosRadY       ;edx:eax := cos(theta)*X
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;sin(theta)*Z
           mov eax, NewZ
           imul SinRadY       ;edx:eax := sin(theta)*Z
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "+"
           add ebx, eax       ;ebx := cos(theta)*X + sin(theta)*Z
           mov NewX, ebx      ;store NewX
       ;NewZ := cos(theta)*Z - sin(theta)*X
         ;cos(theta)*Z
           mov eax, NewZ
           imul CosRadY       ;edx:eax := cos(theta)*Z
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;sin(theta)*X
           mov eax, StaticX
           imul SinRadY       ;edx:eax := sin(theta)*X
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "-"
           sub ebx, eax       ;ebx := cos(theta)*Z - sin(theta)*X
           mov RotateZ, ebx   ;store final Z Rotation value
     ;Rotate about Z Axis
       ;NewZ := Z
       ;NewX := cos(theta)*X - sin(theta)*Y
         ;cos(theta)*X
           mov eax, NewX
           imul CosRadZ       ;edx:eax := cos(theta)*X
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;sin(theta)*Y
           mov eax, NewY
           imul SinRadZ       ;edx:eax := sin(theta)*Y
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "-"
           sub ebx, eax       ;ebx := cos(theta)*X - sin(theta)*Y
           xchg NewX, ebx     ;store NewX, and load 'old'NewX into ebx
                              ;  for next calculation
       ;NewY := sin(theta)*X + cos(theta)*Y
          ;sin(theta)*X
           mov eax, SinRadZ   ;handle next imul backwards
           imul ebx           ;edx:eax := X*sin(theta),
                              ;  'old'NewX already in ebx
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           mov ebx, eax       ;store result in ebx
         ;cos(theta)*Y
           mov eax, NewY
           imul CosRadZ       ;edx:eax := Cos(theta)*Y
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
         ;Do "+"
           add eax, ebx       ;NewY = eax := sin(theta)*X + cos(theta)*Y
                              ;   NewY is stored in eax for next calculation
     ;Do ViewZoom and HalfBmpHeight, HalfBmpWidth
       ;calc and store Rotate.YPlot
         ;Rotate.YPlot := ((-1)*(NewY*ViewZoom))+HalfBmpHeight
           imul ViewZoom      ;edx:eax := NewY(eax) * ViewZoom
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           neg eax                  ;eax := eax * (-1)
           add eax, HalfBmpHeight   ;eax := eax + HalfBmpHeight
           mov RotateYPlot, eax     ;store RotateYPlot
       ;calc and store Rotate.XPlot
         ;Rotate.XPlot := (NewX*ViewZoom)+HalfBmpWidth
           mov eax, NewX
           imul ViewZoom      ;edx:eax := NewX(eax) * ViewZoom
           shrd eax, edx, 16  ;dump lower 16 bits leaving 32 result in eax
           add eax, HalfBmpWidth    ;eax := eax + HalfBmpWidth
           mov RotateXPlot, eax     ;store RotateXPlot
     ;advance to next record
       add si, 24  ;move ds:si to next record (24 = SizeOf(TPixRec))
   loop JmpToTop
     jmp short DontJmpTop
   JmpToTop:
     jmp MainLoopTop
   DontJmpTop:
   popad
   pop si
   pop di
   pop ds
   pop es
   add sp, LocalSpace  ;close stack hole for local variables
   ret
AsmRotateOneArray    ENDP

;---------------------------------------------------------------------

                     END
