.386
.MODEL USE16 large, PASCAL
.CODE

; Fast Graph Source Code Unit.
; Copyright (c) May 25, 1996 Greg VanMullem, All Rights Reserved.

;---------------------------------------------------------------------

; procedure assumes that NumRec > 3
; Initial Gap = NumRec div 2

AsmSortOneLineArray    PROC FAR LineArray:DWORD, NumRec:WORD, Gap:WORD
                       PUBLIC AsmSortOneLineArray
          push es
          push ds
          push di
          push si
          pushad
          RepeatTop1:
            les di, LineArray     ;load I pointer
            lds si, LineArray     ;load pointer to first element in array
            mov ax, 13            ;ax := sizeof(TLineRec)
            mul Gap                ;dx:ax := Gap * ax,sizeof(TLineRec)
            add si, ax            ;point ds:si to [I + Gap] array element
            mov dl, 0             ;dl := Exchange := false
            mov cx, NumRec        ;cx := NumRec
            sub cx, Gap           ;cx := NumRec - Gap
            LoopTop1:
               mov eax, es:[di]   ;eax := LineArray[I].MiddleZ
               mov ebx, ds:[si]   ;ebx := LineArray[I+Gap].MiddleZ
               ;test and swap, set Exchange if Swaped
               cmp eax, ebx
               jl short AroundSwap1    ;if eax < ebx then don't swap
                 jne short AroundEq1   ;if eax = ebx then do extra check
                   mov dh, es:[di+12]  ;dh := LineArray[I].FuncNum
                   cmp dh, ds:[si+12]  ;cmp dh, LineArray[I+Gap].FuncNum
                   jle short AroundSwap1 ;don't swap if La[I].Fn <= La[I+Gap].Fn
                 AroundEq1:
                   ;perform swap
                   mov es:[di], ebx  ;swap Allready loaded MiddleZ's
                   mov ds:[si], eax
                   mov eax, es:[di+4]  ;swap next 4 bytes
                   xchg eax, ds:[si+4]
                   mov es:[di+4], eax
                   mov eax, es:[di+8]  ;swap next 4 bytes
                   xchg eax, ds:[si+8]
                   mov es:[di+8], eax
                   mov al, es:[di+12]  ;swap last byte
                   xchg al, ds:[si+12]
                   mov es:[di+12], al
                   mov dl, 1             ;dl := Exchange := true
               AroundSwap1:
               add di, 13      ;inc I pointer; 13 = sizeof(TLineRec)
               add si, 13      ;inc I+Gap pointer; 13 = sizeof(TLineRec)
            loop LoopTop1
            cmp dl, 0             ;dl = Exchange
            jne short RepeatTop1  ;if Exchange <> false then repeat..until
          ;until not(Exchange)
            shr Gap, 1            ;Gap := Gap div 2
            cmp Gap, 0
            jne short RepeatTop1  ;if Gap < 1 then repeat..until
          ;until (Gap < 1)
          popad
          pop si
          pop di
          pop ds
          pop es
          ret
AsmSortOneLineArray    ENDP

;---------------------------------------------------------------------

; procedure assumes that NumRec > 3
; Initial Gap = NumRec div 2
; var LineI, LineIPlusGap : PLineRec;

AsmSortLines    PROC FAR LinePtrArray:DWORD, NumRec:WORD, Gap:WORD
                PUBLIC AsmSortLines
                LOCAL ILinePtrOffSet:WORD, ILineEnd:WORD, \
                      IpGapLinePtrOffSet:WORD, IpGapLineEnd:WORD
    sub sp, 8  ;open stack hole for local var's
    push es
    push ds
    push gs
    pushad
    RepeatTop2:
      ;calc and store var's needed to traverse line arrays useing
      ;LineI := addr(LinePtrArray[(I div TLineArraySize)]^
      ;                          [(I mod TLineArraySize)]);
        lgs bx, LinePtrArray    ;gs:bx := LinePtrArray
        mov ILinePtrOffSet, bx  ;store offset of LinePtrArray[0]
        les di, gs:[bx]         ;es:di := addr(LinePtrArray[0]^[0])
        mov ax, di
        add ax, 65507  ;ax := addr(LinePtrArray[0]^[TLineArraySize-1]);
                       ;ax := offset of last element in LinePtrArray[0]^
                       ;  65507 = (5040-1)*13
                       ;  TLineArraySize = 5040;
                       ;  TLinePtrArraySize = 13;
        mov ILineEnd, ax  ;store offset of last element in LineArray[0]^
      ;calc and store var's needed to traverse line arrays useing
      ;LineIPlusGap := addr(LinePtrArray[((I + Gap) div TLineArraySize)]^
      ;                                 [((I + Gap) mod TLineArraySize)]);
        xor dx, dx        ;dx := 0
        mov ax, Gap       ;ax := Gap
        mov cx, 5040      ;cx := TLineArraySize = 5040;
        div cx            ;Result,ax Remainder,dx := 0:Gap / TLineArraySize
                          ;  ax := ((I + Gap) div TLineArraySize);
                          ;  dx := ((I + Gap) mod TLineArraySize);
        shl ax, 2         ;Result,ax := Result * 4; (4 byte pointers)
        ;gs:bx := addr(LinePtrArray[((I + Gap) div TLineArraySize)])
          add bx, ax
        mov IpGapLinePtrOffSet, bx   ;store offset
        ;ds:si := addr(LinePtrArray[((I + Gap) div TLineArraySize)]^[0])
          lds si, gs:[bx]
        mov ax, si
        ;ax := addr(LinePtrArray[((I + Gap) div TLineArraySize)]^
        ;                       [TLineArraySize-1]);
        ;calc offset of last element in LineArray[I+Gap]^
          add ax, 65507   ;65507 = (5040-1)*13
                          ;TLineArraySize = 5040; TLinePtrArraySize = 13;
        mov IpGapLineEnd, ax  ;store offset
        mov ax, 13            ;ax := sizeof(TLineRec)
        mul dx                ;dx:ax := Remainder,dx * sizeof(TLineRec)
        add si, ax            ;point ds:si to [I + Gap] array element
      ;setup var's needed for loop
        mov dl, 0             ;dl := Exchange := false
        mov cx, NumRec        ;cx := NumRec
        sub cx, Gap           ;cx := NumRec - Gap
      LoopTop2:
         mov eax, es:[di]   ;eax := LineArray[I].MiddleZ
         mov ebx, ds:[si]   ;ebx := LineArray[I+Gap].MiddleZ
         ;test and swap, set Exchange if Swaped
         cmp eax, ebx
         jl short AroundSwap2    ;if eax < ebx then don't swap
           jne short AroundEq2   ;if eax = ebx then do extra check
             mov dh, es:[di+12]  ;dh := LineArray[I].FuncNum
             cmp dh, ds:[si+12]  ;cmp dh, LineArray[I+Gap].FuncNum
             jle short AroundSwap2  ;don't swap if La[I].Fn <= La[I+Gap].Fn
           AroundEq2:
             ;perform swap
             mov es:[di], ebx  ;swap Allready loaded MiddleZ's
             mov ds:[si], eax
             mov eax, es:[di+4]  ;swap next 4 bytes
             xchg eax, ds:[si+4]
             mov es:[di+4], eax
             mov eax, es:[di+8]  ;swap next 4 bytes
             xchg eax, ds:[si+8]
             mov es:[di+8], eax
             mov al, es:[di+12]  ;swap last byte
             xchg al, ds:[si+12]
             mov es:[di+12], al
             mov dl, 1             ;dl := Exchange := true
         AroundSwap2:
         ;advance es:di to next lineRec
           cmp di, ILineEnd
           jne short AroundNextISeg2
             ;advance es:di to next segment (line array)
             add ILinePtrOffset, 4  ;next pointer in array
             mov bx, ILinePtrOffset
             les di, gs:[bx]        ;es:di := addr(LinePtrArray[next]^[0])
             ;ax := offset of last element in LinePtrArray[next]^
               mov ax, di
               add ax, 65507  ;65507 = (5040-1)*13
                              ;  TLineArraySize = 5040;
                              ;  TLinePtrArraySize = 13;
             ;store offset of last element in LineArray[next]^
               mov ILineEnd, ax
             jmp short AroundDI2
           AroundNextISeg2:
             add di, 13      ;inc I pointer; 13 = sizeof(TLineRec)
           AroundDI2:
         ;advance ds:si to next lineRec
           cmp si, IpGapLineEnd
           jne short AroundNextIpGapSeg2
             ;advance ds:si to next segment (line array)
             add IpGapLinePtrOffset, 4  ;next pointer in array
             mov bx, IpGapLinePtrOffset
             lds si, gs:[bx]        ;ds:si := addr(LinePtrArray[next]^[0])
             ;ax := offset of last element in LinePtrArray[next]^
               mov ax, si
               add ax, 65507  ;65507 = (5040-1)*13
                              ;  TLineArraySize = 5040;
                              ;  TLinePtrArraySize = 13;
             ;store offset of last element in LineArray[next]^
               mov IpGapLineEnd, ax
             jmp short AroundSI2
           AroundNextIpGapSeg2:
             add si, 13      ;inc I+Gap pointer; 13 = sizeof(TLineRec)
           AroundSI2:
      loop JmpToTop
        jmp short DontJmpTop
      JmpToTop:
        jmp LoopTop2
      DontJmpTop:
      cmp dl, 0             ;dl = Exchange
      jne RepeatTop2   ;if Exchange <> false then repeat..until
    ;until not(Exchange)
      shr Gap, 1            ;Gap := Gap div 2
      cmp Gap, 0
      jne RepeatTop2   ;if Gap < 1 then repeat..until
    ;until (Gap < 1)
    popad
    pop gs
    pop ds
    pop es
    add sp, 8  ;close stack hole for local var's
    ret
AsmSortLines           ENDP

;---------------------------------------------------------------------

                       END