unit Fsmain;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, fgAbout,
  Buttons, StdCtrls, Status, FileSave, PrntScal, Calculat, ComCtrls,
  Clsample, ToolWin, ImgList, ExtCtrls, HotKey2D, HotKeyPo, HotKey3D,
  OptDlg, MathCalc, MathFunc, CentrDlg, ComnDlgs, GenOptns, GrDraw, DgDraw,
  DgGlobal, IniFiles, WinBase, WinGraph, Wind2D, WindPolr, Wind3D,
  GrGlobal;

const
  MaxFileListCount = 5;
  FirstFileListIndex = 16; //this must change when the file menu changes.

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    FileMenu1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Window1: TMenuItem;
    ArrangeAll1: TMenuItem;
    Cascade1: TMenuItem;
    Tile1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    New3DCartisian1: TMenuItem;
    ColorDialog1: TColorDialog;
    Print1: TMenuItem;
    SaveMGFDialog: TSaveDialog;
    New2DCartisian1: TMenuItem;
    New2DPolar1: TMenuItem;
    Graph2: TMenuItem;
    BitmapSize1: TMenuItem;
    N4: TMenuItem;
    CopyBitmaptoClopboard1: TMenuItem;
    N5: TMenuItem;
    N7: TMenuItem;
    SelectBitmapRegion1: TMenuItem;
    FontDialog1: TFontDialog;
    BitmapRegionDialog1: TMenuItem;
    N8: TMenuItem;
    PrintScale1: TMenuItem;
    CenterBitmap1: TMenuItem;
    SaveFile1: TMenuItem;
    SaveFileAs1: TMenuItem;
    OpenFile1: TMenuItem;
    CloseFile1: TMenuItem;
    OpenDialog1: TOpenDialog;
    hlp1: TMenuItem;
    N9: TMenuItem;
    SaveAsBMPFile1: TMenuItem;
    SaveBMPDialog: TSaveDialog;
    FileSeparatorLine: TMenuItem;
    FL1: TMenuItem;
    FL2: TMenuItem;
    FL3: TMenuItem;
    FL4: TMenuItem;
    FL5: TMenuItem;
    ControlBar1: TControlBar;
    ControlBar2: TControlBar;
    StatusBar: TStatusBar;
    ToolShapeImageList1: TImageList;
    Tools1: TMenuItem;
    ShowShapeToolBar1: TMenuItem;
    FunctionCalculator1: TMenuItem;
    N2: TMenuItem;
    ResizeLabelsMode1: TMenuItem;
    OpenTextLabelFontDialog1: TMenuItem;
    ShowHideGraphViewToolBar1: TMenuItem;
    GraphImageList1: TImageList;
    LabelShapeToolBar: TToolBar;
    ShapeOffButton: TToolButton;
    LineButton: TToolButton;
    RectangleButton: TToolButton;
    EllipseButton: TToolButton;
    RoundRectButton: TToolButton;
    FreeHandButton: TToolButton;
    FloodFillButton: TToolButton;
    TextButton: TToolButton;
    ToolButton3: TToolButton;
    LabelPenColorButton: TToolButton;
    ClearPen: TToolButton;
    SolidPen: TToolButton;
    DashPen: TToolButton;
    DotPen: TToolButton;
    DashDotPen: TToolButton;
    DashDotDotPen: TToolButton;
    ToolButton11: TToolButton;
    ToolButton13: TToolButton;
    LabelPenColorSample: TColorSample;
    ToolButton14: TToolButton;
    LabelBrushColorSample: TColorSample;
    LabelBrushColorButton: TToolButton;
    ClearBrush: TToolButton;
    SolidBrush: TToolButton;
    HorizontalBrush: TToolButton;
    VerticalBrush: TToolButton;
    ForwardDiagonalBrush: TToolButton;
    BackwardDiagonalBrush: TToolButton;
    CrossBrush: TToolButton;
    DiagonalCrossBrush: TToolButton;
    FontNameCombo: TComboBox;
    FontSizeCombo: TComboBox;
    ToolButton25: TToolButton;
    BoldFontButton: TToolButton;
    ItalicFontButton: TToolButton;
    UnderlineFontButton: TToolButton;
    GraphToolBar: TToolBar;
    New2DButton: TToolButton;
    NewPolarButton: TToolButton;
    New3DButton: TToolButton;
    OpenFileButton: TToolButton;
    SaveFileButton: TToolButton;
    GraphTBarSpace1: TToolButton;
    CenterFuncButton: TToolButton;
    CenterBmpButton: TToolButton;
    GraphTBarSpace2: TToolButton;
    ZoomInButton: TToolButton;
    ZoomOutButton: TToolButton;
    ZoomXInButton: TToolButton;
    ZoomXOutButton: TToolButton;
    ZoomYInButton: TToolButton;
    ZoomYOutButton: TToolButton;
    GraphTBarSpace3: TToolButton;
    ScrollUpButton: TToolButton;
    ScrollDownButton: TToolButton;
    ScrollLeftButton: TToolButton;
    ScrollRightButton: TToolButton;
    GraphTBarSpace4: TToolButton;
    PageUpButton: TToolButton;
    PageDownButton: TToolButton;
    PageLeftButton: TToolButton;
    PageRightButton: TToolButton;
    RotateUpButton: TToolButton;
    RotateDownButton: TToolButton;
    RotateLeftButton: TToolButton;
    RotateRightButton: TToolButton;
    RotateZLeftButton: TToolButton;
    RotateZRightButton: TToolButton;
    LabelPenWidthPanel1: TPanel;
    LabelPenSize: TLabel;
    LabelPenWidthScroll: TScrollBar;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    PrintScaleDialog1: TPrintDialog;
    Options1: TMenuItem;
    N6: TMenuItem;
    N10: TMenuItem;
    Timer1: TTimer;
    N11: TMenuItem;
    RedrawWindow1: TMenuItem;
    StopDrawingWindow1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure New2DCartisian1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeAll1Click(Sender: TObject);
    procedure New2DPolar1Click(Sender: TObject);
    procedure New3DCartisian1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure CopyBitmapToClipBoard1Click(Sender: TObject);
    procedure PrintScale1Click(Sender: TObject);
    procedure CenterBitmap1Click(Sender: TObject);
    procedure CloseFile1Click(Sender: TObject);
    procedure SaveFileAs1Click(Sender: TObject);
    procedure SaveFile1Click(Sender: TObject);
    procedure OpenFile1Click(Sender: TObject);
    procedure hlp1Click(Sender: TObject);
    procedure SaveAsBMPFile1Click(Sender: TObject);
    procedure FileListClick(Sender: TObject);
    procedure LabelPenColorButtonClick(Sender: TObject);
    procedure ShapeButtonClick(Sender: TObject);
    procedure LabelPenStyleClick(Sender: TObject);
    procedure LabelPenWidthScrollChange(Sender: TObject);
    procedure LabelBrushColorButtonClick(Sender: TObject);
    procedure LabelBrushStyleClick(Sender: TObject);
    procedure FunctionCalculator1Click(Sender: TObject);
    procedure ResizeLabelsMode1Click(Sender: TObject);
    procedure OpenTextLabelFontDialog1Click(Sender: TObject);
    procedure FontNameComboChange(Sender: TObject);
    procedure FontSizeComboExit(Sender: TObject);
    procedure FontSizeComboChange(Sender: TObject);
    procedure FontAttribButtonClick(Sender: TObject);
    procedure ShowHideGraphViewToolBar1Click(Sender: TObject);
    procedure CenterFuncButtonClick(Sender: TObject);
    procedure ZoomButtonClick(Sender: TObject);
    procedure ZoomAxisButtonClick(Sender: TObject);
    procedure ScrollButtonClick(Sender: TObject);
    procedure PageButtonClick(Sender: TObject);
    procedure RotateButtonClick(Sender: TObject);
    procedure StatusBarResize(Sender: TObject);
    procedure ShowShapeToolBar1Click(Sender: TObject);
    procedure ShowOptionsDlgClick(Sender: TObject);
    procedure ColorDialog1Show(Sender: TObject);
    procedure FontDialog1Show(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ZoomButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RepeatingButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ZoomAxisButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PageButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RotateButtonMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure RepeatingButtonMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PrintScaleDialog1Show(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RedrawWindow1Click(Sender: TObject);
    procedure StopDrawingWindow1Click(Sender: TObject);
    procedure SelectBitmapRegion1Click(Sender: TObject);
    procedure BitmapSize1Click(Sender: TObject);
    procedure BitmapRegionDialog1Click(Sender: TObject);
  private
    { Private declarations }
    RepeatingToolBarClick : TNotifyEvent;
    RepeatingToolBarSender : TObject;
    AllowIniFileChanges : boolean;
    GraphTBarIniVisible : boolean;
    LabelTBarIniVisible : boolean;
    FGeneralOptionsObj : TGeneralOptionsObj;
    FStatusLineObj : TStatusLineObj;
    FHotKey2DObj : THotKey2DObj;
    FHotKeyPolarObj : THotKeyPolarObj;
    FHotKey3DObj : THotKey3DObj;
    FOpenWinCount : integer;
    FDrawingTool : TDrawingTool;
    FToolBarAttribClass : TToolBarAttribClass;
    FileListCount : integer;
    FileListStrings : array[1..MaxFileListCount] of string;
    procedure ResetOpenWindowCount;
    procedure UpdateFontSizesCombo;
    procedure UpdateFontFields;
    procedure EnableWinMenuItems;
    procedure DisableWinMenuItems;
    function IsFreeGraphWindowSlot : boolean;
    function DoCallOpenTheFile(const TheFStr : string) : boolean;
    function GetResizeLabelsMode : boolean;
    procedure UpdateOptionValues;
    procedure ReadOptionsFromIniFiles;
    procedure SaveOptionsToIniFiles;
    procedure SaveToolBarVisToIniFiles;
    procedure DoZoomButtonHit(Sender: TObject);
    procedure DoZoomAxisButtonHit(Sender: TObject);
    procedure DoScrollButtonHit(Sender: TObject);
    procedure DoPageButtonHit(Sender: TObject);
    procedure DoRotateButtonHit(Sender: TObject);
    function HTMLHelpEventHandler(Command: Word; Data: Longint;
                      var CallHelp: Boolean): Boolean;
  public
    { Public declarations }
    VertResolu : Integer;
    FCenterColorDlgOnForm : TForm;
    FCenterFontDlgOnForm : TForm;
    property GeneralOptionsObj : TGeneralOptionsObj read FGeneralOptionsObj;
    property StatusLineObj : TStatusLineObj read FStatusLineObj;
    property HotKey2DObj : THotKey2DObj read FHotKey2DObj;
    property HotKeyPolarObj : THotKeyPolarObj read FHotKeyPolarObj;
    property HotKey3DObj : THotKey3DObj read FHotKey3DObj;
    property DrawingTool : TDrawingTool read FDrawingTool;
    property ToolBarAttribClass : TToolBarAttribClass read FToolBarAttribClass;
    property ResizeLabelsMode : boolean read GetResizeLabelsMode;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure TurnDrawingToolOff;
    procedure GraphDeactivateMessage;
    procedure Graph2DActivateMessage;
    procedure GraphPolarActivateMessage;
    procedure Graph3DActivateMessage;
    procedure IncWinCount;
    procedure DecWinCount;
    procedure OpenParamStrDataFile;
    procedure AddFileNameToList(const FNameStr : string);
  end; {TMainForm}

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

const
  IniFileNameString = 'mathgv.ini';
  sec_CanSaveOptions = 'CanSaveOptions';
    key_AllowIniFileChanges = 'AllowIniFileChanges';
  sec_ToolBarVisibility = 'ToolBarVisibility';
    key_ShowGraphToolBar = 'ShowGraphToolBar';
    key_ShowLabelToolBar = 'ShowLabelToolBar';

{---------------------------------------------------------------------}

procedure LockSystemFormatSettings;
const //0=nul; 9=TAB; 10=LF; 13=CR;
  InvalidSeparatorSet = ['A'..'Z', 'a'..'z', '0'..'9', '+', '-', '*', '/', '^',
                         '{', '}', '[', ']', '(', ')', ' ',
                         Char(0), Char(9), Char(10), Char(13)];
begin {procedure LockSystemFormatSettings;}
  Application.UpdateFormatSettings := False;
  //0=nul; 9=TAB; 10=LF; 13=CR;
  if DecimalSeparator in InvalidSeparatorSet then
    DecimalSeparator := '.';
end; {procedure LockSystemFormatSettings;}

{---------------------------------------------------------------------}

constructor TMainForm.Create(AOwner: TComponent);
var
  I : integer;
begin {constructor TMainForm.Create;}
  inherited Create(AOwner);
  LockSystemFormatSettings; //must be first line
  //ForceCurrentDirectory := True; //may want to use some day, as an option.
  //begin variables used by Repeating Tool Bar Timer
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  //end variables used by Repeating Tool Bar Timer
  FCenterColorDlgOnForm := nil;
  FCenterFontDlgOnForm := nil;
  //begin get settings from ini file
  AllowIniFileChanges := true;
  GraphTBarIniVisible := true;
  LabelTBarIniVisible := false;
  FGeneralOptionsObj := TGeneralOptionsObj.Create;
  FStatusLineObj := TStatusLineObj.Create;
  FHotKey2DObj := THotKey2DObj.Create;
  FHotKeyPolarObj := THotKeyPolarObj.Create;
  FHotKey3DObj := THotKey3DObj.Create;
  ReadOptionsFromIniFiles;
  GraphToolBar.Visible := GraphTBarIniVisible;
  LabelShapeToolBar.Visible := LabelTBarIniVisible;
  UpdateOptionValues;
  //end get settings from ini file
  FDrawingTool := dtOff;
  ShapeOffButton.Down := true;
  FToolBarAttribClass := TToolBarAttribClass.Create;
  LabelBrushColorSample.ColorValue := FToolBarAttribClass.BrushColor;
  LabelPenColorSample.ColorValue := FToolBarAttribClass.PenColor;
  FOpenWinCount := 0;
  FileListCount := 0;
  for I := 1 to MaxFileListCount do
    FileListStrings[I] := '';
  DisableWinMenuItems;
  VertResolu := GetDeviceCaps(Canvas.Handle, LOGPIXELSY);
  FontNameCombo.Items := Screen.Fonts;
  UpdateFontFields;
  Application.OnHelp := HTMLHelpEventHandler;
end; {constructor TMainForm.Create;}

{---------------------------------------------------------------------}

destructor TMainForm.Destroy;
begin {destructor TMainForm.Destroy;}
  FGeneralOptionsObj.free;
  FStatusLineObj.free;
  FHotKey2DObj.free;
  FHotKeyPolarObj.free;
  FHotKey3DObj.free;
  FToolBarAttribClass.free;
  inherited Destroy;
end; {destructor TMainForm.Destroy;}

{---------------------------------------------------------------------}

function TMainForm.HTMLHelpEventHandler(Command: Word; Data: Longint;
                                        var CallHelp: Boolean): Boolean;
//this function handles help events and calls the HTML help api
var
    uCommand : word;
begin {function TMainForm.HTMLHelpEventHandler}
    //stop the VCL from calling help API's
    CallHelp := false;
    result := true;
    //map commands
    case Command of
      HELP_CONTENTS:
        begin
            uCommand :=  HH_DISPLAY_TOC;
            Data := 0;
        end;
      HELP_CONTEXT, HELP_CONTEXTPOPUP:
        uCommand := HH_HELP_CONTEXT;
      HELP_FINDER:
        uCommand := HH_DISPLAY_TOPIC;
      HELP_KEY:
        uCommand := HH_DISPLAY_INDEX;
      HELP_QUIT:
        begin
          uCommand :=  HH_CLOSE_ALL;
          Data := 0;
        end;
      else
        begin
            uCommand := HH_DISPLAY_TOPIC;
            Data := 0;
        end;
    end;
    //call API
    HtmlHelp(Application.Handle, PChar(Application.HelpFile), uCommand, Data);
end; {function TMainForm.HTMLHelpEventHandler}

{---------------------------------------------------------------------}

procedure TMainForm.TurnDrawingToolOff;
begin {procedure TMainForm.TurnDrawingToolOff;}
  if FDrawingTool <> dtOff then
    begin
      SelectBitmapRegion1.Checked := false;
      ShapeOffButton.Down := true;
      FDrawingTool := dtOff;
    end; {if}
end; {procedure TMainForm.TurnDrawingToolOff;}

{---------------------------------------------------------------------}

procedure TMainForm.AddFileNameToList(const FNameStr : string);
var
  I : integer;
begin {procedure TMainForm.AddFileNameToList}
  if FNameStr <> '' then
    begin
      {begin search for existing dupe}
      for I := 1 to FileListCount do
        begin
          if FNameStr = FileListStrings[I] then
            Exit; {got a dupe}
        end; {for}
      {end search for existing dupe}
      if FileListCount < MaxFileListCount then
        inc(FileListCount);
      FileSeparatorLine.Visible := true;
      {move FileListStrings down}
      for I := (MaxFileListCount-1) downto 1 do
         FileListStrings[I+1] := FileListStrings[I];
      FileListStrings[1] := FNameStr;
      for I := 1 to MaxFileListCount do
        begin
          if FileListCount >= I then
            begin
              FileMenu1.items[I+(FirstFileListIndex-1)].Caption :=
                        ExtractFileName(FileListStrings[I]);
              FileMenu1.items[I+(FirstFileListIndex-1)].visible := true;
            end
          else
            begin
              FileMenu1.items[I+(FirstFileListIndex-1)].Caption := '';
              FileMenu1.items[I+(FirstFileListIndex-1)].visible := false;
            end; {else}
        end; {for}
    end; {if}
end; {procedure TMainForm.AddFileNameToList}

{---------------------------------------------------------------------}

procedure TMainForm.FileListClick(Sender: TObject);
var
  I, J : integer;
begin
  if IsFreeGraphWindowSlot then
  begin
    I := TMenuItem(Sender).Tag;
    if (I >= 1) and (I <= FileListCount) then
      begin
        if DoCallOpenTheFile(FileListStrings[I]) then
          begin
            for J := I to (MaxFileListCount-1) do
              FileListStrings[J] := FileListStrings[J+1];
            FileListStrings[MaxFileListCount] := '';
            dec(FileListCount);
            if FileListCount <= 0 then
              FileSeparatorLine.Visible := false;
            for I := 1 to MaxFileListCount do
              begin
                if FileListCount >= I then
                  begin
                    FileMenu1.items[I+(FirstFileListIndex-1)].Caption :=
                              ExtractFileName(FileListStrings[I]);
                    FileMenu1.items[I+(FirstFileListIndex-1)].visible:= true;
                  end
                else
                  begin
                    FileMenu1.items[I+(FirstFileListIndex-1)].Caption := '';
                    FileMenu1.items[I+(FirstFileListIndex-1)].visible:= false;
                  end; {else}
              end; {for}
          end; {if}
      end; {if}
  end; {if}
end;

{---------------------------------------------------------------------}

procedure TMainForm.EnableWinMenuItems;
begin {procedure TMainForm.EnableWinMenuItems;}
  SaveFile1.Enabled := true;
  SaveFileAs1.Enabled := true;
  PrintScale1.Enabled := true;
  Print1.Enabled := true;
  CloseFile1.Enabled := true;
  SaveAsBMPFile1.Enabled := true;
  BitmapSize1.Enabled := true;
  CopyBitmaptoClopboard1.Enabled := true;
  SelectBitmapRegion1.Enabled := true;
  BitmapRegionDialog1.Enabled := true;
  CenterBitmap1.Enabled := true;
  RedrawWindow1.Enabled := true;
  StopDrawingWindow1.Enabled := true;
  if Assigned(GraphToolBar) then
    begin
      SaveFileButton.Enabled := true;
      CenterFuncButton.Enabled := true;
      CenterBmpButton.Enabled := true;
      ZoomInButton.Enabled := true;
      ZoomOutButton.Enabled := true;
    end; {if}
end; {procedure TMainForm.EnableWinMenuItems;}

{---------------------------------------------------------------------}

procedure TMainForm.DisableWinMenuItems;
begin {procedure TMainForm.DisableWinMenuItems;}
  SaveFile1.Enabled := false;
  SaveFileAs1.Enabled := false;
  PrintScale1.Enabled := false;
  Print1.Enabled := false;
  CloseFile1.Enabled := false;
  SaveAsBMPFile1.Enabled := false;
  BitmapSize1.Enabled := false;
  CopyBitmaptoClopboard1.Enabled := false;
  SelectBitmapRegion1.Enabled := false;
  BitmapRegionDialog1.Enabled := false;
  CenterBitmap1.Enabled := false;
  RedrawWindow1.Enabled := false;
  StopDrawingWindow1.Enabled := false;
  if Assigned(GraphToolBar) then
    begin
      SaveFileButton.Enabled := false;
      CenterFuncButton.Enabled := false;
      CenterBmpButton.Enabled := false;
      ZoomInButton.Enabled := false;
      ZoomOutButton.Enabled := false;
    end; {if}
end; {procedure TMainForm.DisableWinMenuItems;}

{---------------------------------------------------------------------}

procedure TMainForm.GraphDeactivateMessage;
begin {procedure TMainForm.GraphDeactivateMessage;}
  if Assigned(GraphToolBar) then
    begin
      ZoomXInButton.Visible := false;
      ZoomXOutButton.Visible := false;
      ZoomYInButton.Visible := false;
      ZoomYOutButton.Visible := false;
      GraphTBarSpace3.Style := tbsButton;
      GraphTBarSpace3.Visible := false;
      GraphTBarSpace3.Style := tbsSeparator;
      ScrollUpButton.Visible := false;
      ScrollDownButton.Visible := false;
      ScrollLeftButton.Visible := false;
      ScrollRightButton.Visible := false;
      GraphTBarSpace4.Style := tbsButton;
      GraphTBarSpace4.Visible := false;
      GraphTBarSpace4.Style := tbsSeparator;
      PageUpButton.Visible := false;
      PageDownButton.Visible := false;
      PageLeftButton.Visible := false;
      PageRightButton.Visible := false;
      RotateUpButton.Visible := false;
      RotateDownButton.Visible := false;
      RotateLeftButton.Visible := false;
      RotateRightButton.Visible := false;
      RotateZLeftButton.Visible := false;
      RotateZRightButton.Visible := false;
    end; {if}
end; {procedure TMainForm.GraphDeactivateMessage;}

{---------------------------------------------------------------------}

procedure TMainForm.Graph2DActivateMessage;
begin {procedure TMainForm.Graph2DActivateMessage;}
  if Assigned(GraphToolBar) then
    begin
      ZoomXInButton.Visible := true;
      ZoomXOutButton.Visible := true;
      ZoomYInButton.Visible := true;
      ZoomYOutButton.Visible := true;
      GraphTBarSpace3.Style := tbsButton;
      GraphTBarSpace3.Visible := true;
      GraphTBarSpace3.Style := tbsSeparator;
      ScrollUpButton.Visible := true;
      ScrollDownButton.Visible := true;
      ScrollLeftButton.Visible := true;
      ScrollRightButton.Visible := true;
      GraphTBarSpace4.Style := tbsButton;
      GraphTBarSpace4.Visible := true;
      GraphTBarSpace4.Style := tbsSeparator;
      PageUpButton.Visible := true;
      PageDownButton.Visible := true;
      PageLeftButton.Visible := true;
      PageRightButton.Visible := true;
      RotateUpButton.Visible := false;
      RotateDownButton.Visible := false;
      RotateLeftButton.Visible := false;
      RotateRightButton.Visible := false;
      RotateZLeftButton.Visible := false;
      RotateZRightButton.Visible := false;
    end; {if}
end; {procedure TMainForm.Graph2DActivateMessage;}

{---------------------------------------------------------------------}

procedure TMainForm.GraphPolarActivateMessage;
begin {procedure TMainForm.GraphPolarActivateMessage;}
  if Assigned(GraphToolBar) then
    begin
      ZoomXInButton.Visible := false;
      ZoomXOutButton.Visible := false;
      ZoomYInButton.Visible := false;
      ZoomYOutButton.Visible := false;
      GraphTBarSpace3.Style := tbsButton;
      GraphTBarSpace3.Visible := true;
      GraphTBarSpace3.Style := tbsSeparator;
      ScrollUpButton.Visible := true;
      ScrollDownButton.Visible := true;
      ScrollLeftButton.Visible := true;
      ScrollRightButton.Visible := true;
      GraphTBarSpace4.Style := tbsButton;
      GraphTBarSpace4.Visible := true;
      GraphTBarSpace4.Style := tbsSeparator;
      PageUpButton.Visible := true;
      PageDownButton.Visible := true;
      PageLeftButton.Visible := true;
      PageRightButton.Visible := true;
      RotateUpButton.Visible := false;
      RotateDownButton.Visible := false;
      RotateLeftButton.Visible := false;
      RotateRightButton.Visible := false;
      RotateZLeftButton.Visible := false;
      RotateZRightButton.Visible := false;
    end; {if}
end; {procedure TMainForm.GraphPolarActivateMessage;}

{---------------------------------------------------------------------}

procedure TMainForm.Graph3DActivateMessage;
begin {procedure TMainForm.Graph3DActivateMessage;}
  if Assigned(GraphToolBar) then
    begin
      ZoomXInButton.Visible := false;
      ZoomXOutButton.Visible := false;
      ZoomYInButton.Visible := false;
      ZoomYOutButton.Visible := false;
      GraphTBarSpace3.Style := tbsButton;
      GraphTBarSpace3.Visible := false;
      GraphTBarSpace3.Style := tbsSeparator;
      GraphTBarSpace3.Visible := false;
      ScrollUpButton.Visible := false;
      ScrollDownButton.Visible := false;
      ScrollLeftButton.Visible := false;
      ScrollRightButton.Visible := false;
      PageUpButton.Visible := false;
      PageDownButton.Visible := false;
      PageLeftButton.Visible := false;
      PageRightButton.Visible := false;
      GraphTBarSpace4.Style := tbsButton;
      GraphTBarSpace4.Visible := true;
      GraphTBarSpace4.Style := tbsSeparator;
      RotateUpButton.Visible := true;
      RotateDownButton.Visible := true;
      RotateLeftButton.Visible := true;
      RotateRightButton.Visible := true;
      RotateZLeftButton.Visible := true;
      RotateZRightButton.Visible := true;
    end; {if}
end; {procedure TMainForm.Graph3DActivateMessage;}

{---------------------------------------------------------------------}

procedure TMainForm.IncWinCount;
begin {procedure TMainForm.IncWinCount;}
  inc(FOpenWinCount);
  EnableWinMenuItems;
end; {procedure TMainForm.IncWinCount;}

{---------------------------------------------------------------------}

procedure TMainForm.DecWinCount;
begin {procedure TMainForm.DecWinCount;}
  Dec(FOpenWinCount);
  if FOpenWinCount <= 0 then
    begin
      FOpenWinCount := 0;
      DisableWinMenuItems;
    end; {if}
end; {procedure TMainForm.DecWinCount;}

{---------------------------------------------------------------------}

procedure TMainForm.ResetOpenWindowCount;
begin {procedure TMainForm.ResetOpenWindowCount;}
  FOpenWinCount := MDIChildCount;
  if FOpenWinCount <= 0 then
    begin
      FOpenWinCount := 0;
      DisableWinMenuItems;
    end
  else
    EnableWinMenuItems;
end; {procedure TMainForm.ResetOpenWindowCount;}

{---------------------------------------------------------------------}

function TMainForm.GetResizeLabelsMode : boolean;
begin {function TMainForm.GetResizeLabelsMode}
  Result := ResizeLabelsMode1.Checked;
end; {function TMainForm.GetResizeLabelsMode}

{---------------------------------------------------------------------}

function TMainForm.IsFreeGraphWindowSlot : boolean;
begin {function TMainForm.IsFreeGraphWindowSlot}
  Result := true;
  if MDIChildCount >= MaxOpenGraphWindowCount then
    begin
      Result := false;
      MessageDlgCenter('A maximum of '+ IntToStr(MaxOpenGraphWindowCount) +
          ' graph windows may be open at once.', mtError, [mbOK], 0, Self);
    end; {if}
end; {function TMainForm.IsFreeGraphWindowSlot}

{---------------------------------------------------------------------}

function TMainForm.DoCallOpenTheFile(const TheFStr : string) : boolean;
var
  ThePlotWin : TWindowBase;
  ReadGraphFile : TReadGraphFile;
  TmpColorDepth : TPixelFormat;
begin {function TMainForm.DoCallOpenTheFile}
  Result := false;
  ReadGraphFile := TReadGraphFile.Create;
  if not Assigned(ReadGraphFile) then
    Exit;
  try
    if ReadGraphFile.OpenAndCheckFile(TheFStr, DecimalSeparator) then
      begin
        ThePlotWin := nil;
        case ReadGraphFile.GraphType of
          grType2D :
            ThePlotWin := TWindow2D.Create(Application);
          grType2DPolar :
            ThePlotWin := TWindowPolar.Create(Application);
          grType3D :
            ThePlotWin := TWindow3D.Create(Application);
        end; {case}
        try
          if GeneralOptionsObj.DefaultColorDepth in SupportedBmpColorDepths then
            TmpColorDepth := GeneralOptionsObj.DefaultColorDepth
          else
            TmpColorDepth := GetScreenBMPPixelFormat;
          //This next line will close file.
          if ThePlotWin.InitalizeFromFile(TmpColorDepth, TheFStr, ReadGraphFile) then
            begin
              ThePlotWin.CenterTheBitmap;
              ThePlotWin.Show;
              ThePlotWin.ReStartGraphThread;
              Result := true;
            end; {if}
        except
          Result := false;
        end; {try..except}
        if not Result then
          begin
            ThePlotWin.Free;
            ResetOpenWindowCount;
          end; {if}
      end; {if}
  except
    Result := false;
  end; {try..except}
  ReadGraphFile.Free; //This will close file.
end; {function TMainForm.DoCallOpenTheFile}

{---------------------------------------------------------------------}

procedure TMainForm.OpenParamStrDataFile;
var
  I, TmpCount : integer;
  TmpStr : string;
begin {procedure TMainForm.OpenParamStrDataFile;}
  TmpCount := ParamCount;
  if TmpCount > 1024 then //simple validation
    TmpCount := 1024;
  for I := 1 to TmpCount do
    begin
      TmpStr := ParamStr(I);
      if TmpStr <> '' then
        if FileExists(TmpStr) then
          if IsFreeGraphWindowSlot then
            DoCallOpenTheFile(TmpStr)
          else
            Exit;
    end; {for}
end; {procedure TMainForm.OpenParamStrDataFile;}

{---------------------------------------------------------------------}

function EnumFontFamProc(var LogFont: TLogFont; var TextMetric:
  TTextMetric; FontType: Integer;
  TF: TMainForm): Integer; Export; StdCall;
var
  S : string;
begin
  if FontType and TRUETYPE_FONTTYPE > 0 then
    Result := 0 {stop enumerating}
  else
    begin
      Result := 1;
      {calc points from TextMetric.tmHeight, per Microsoft}
      S := Format('%.2d', [Round((TextMetric.tmHeight -
        TextMetric.tmInternalLeading)*72 / TF.VertResolu)]);
      with TF.FontSizeCombo.Items do
        if IndexOf(S) = -1 then
          Add(S);
    end;
end;

{---------------------------------------------------------------------}

procedure TMainForm.UpdateFontSizesCombo;
var
  TmpFontNameStr : string;
begin {procedure TMainForm.UpdateFontSizesCombo;}
  TmpFontNameStr := FToolBarAttribClass.Font.Name;
  FontSizeCombo.Clear;
  EnumFontFamilies(Canvas.Handle, PChar(TmpFontNameStr),
                   @EnumFontFamProc, LongInt(Self));
  if FontSizeCombo.Items.Count = 0 then {is TrueType}
    FontSizeCombo.Items.SetText(TrueTypeFontSizes);
  FontSizeCombo.Text := IntToStr(FToolBarAttribClass.Font.Size);
end; {procedure TMainForm.UpdateFontSizesCombo;}

{---------------------------------------------------------------------}

procedure TMainForm.UpdateFontFields;
begin {procedure TMainForm.UpdateFontFields;}
  with FToolBarAttribClass.Font do
    begin
      FontNameCombo.ItemIndex := FontNameCombo.Items.IndexOf(Name);
      UpdateFontSizesCombo;
      BoldFontButton.Down := (fsBold in Style);
      ItalicFontButton.Down := (fsItalic in Style);
      UnderlineFontButton.Down := (fsUnderline in Style);
    end; {with}
end; {procedure TMainForm.UpdateFontFields;}

{---------------------------------------------------------------------}

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  ShowTheAboutBox;
end;

procedure TMainForm.New2DCartisian1Click(Sender: TObject);
var
  Window2D : TWindow2D;
  TmpColorDepth : TPixelFormat;
begin
  if IsFreeGraphWindowSlot then
    begin
      Window2D := TWindow2D.Create(Application);
      try
        if GeneralOptionsObj.DefaultColorDepth in SupportedBmpColorDepths then
          TmpColorDepth := GeneralOptionsObj.DefaultColorDepth
        else
          TmpColorDepth := GetScreenBMPPixelFormat;
        Window2D.InitalizeNew(TmpColorDepth,
                              GeneralOptionsObj.DefaultBmpWidth,
                              GeneralOptionsObj.DefaultBmpHeight);
        Window2D.CenterTheBitmap;
        Window2D.Show;
        Window2D.ReStartGraphThread;
      except
        Window2D.Free;
        MessageDlgErrorOutOfMemoryNoWait;
        ResetOpenWindowCount;
      end; {try..except}
    end; {if}
end;

procedure TMainForm.New2DPolar1Click(Sender: TObject);
var
  WindowPolar : TWindowPolar;
  TmpColorDepth : TPixelFormat;
begin
  if IsFreeGraphWindowSlot then
    begin
      WindowPolar := TWindowPolar.Create(Application);
      try
        if GeneralOptionsObj.DefaultColorDepth in SupportedBmpColorDepths then
          TmpColorDepth := GeneralOptionsObj.DefaultColorDepth
        else
          TmpColorDepth := GetScreenBMPPixelFormat;
        WindowPolar.InitalizeNew(TmpColorDepth,
                              GeneralOptionsObj.DefaultBmpWidth,
                              GeneralOptionsObj.DefaultBmpHeight);
        WindowPolar.CenterTheBitmap;
        WindowPolar.Show;
        WindowPolar.ReStartGraphThread;
      except
        WindowPolar.Free;
        MessageDlgErrorOutOfMemoryNoWait;
        ResetOpenWindowCount;
      end; {try..except}
    end; {if}
end;

procedure TMainForm.New3DCartisian1Click(Sender: TObject);
var
  Window3D : TWindow3D;
  TmpColorDepth : TPixelFormat;
begin
  if IsFreeGraphWindowSlot then
    begin
      Window3D := TWindow3D.Create(Application);
      try
        if GeneralOptionsObj.DefaultColorDepth in SupportedBmpColorDepths then
          TmpColorDepth := GeneralOptionsObj.DefaultColorDepth
        else
          TmpColorDepth := GetScreenBMPPixelFormat;
        Window3D.InitalizeNew(TmpColorDepth,
                              GeneralOptionsObj.DefaultBmpWidth,
                              GeneralOptionsObj.DefaultBmpHeight);
        Window3D.CenterTheBitmap;
        Window3D.Show;
        Window3D.ReStartGraphThread;
      except
        Window3D.Free;
        MessageDlgErrorOutOfMemoryNoWait;
        ResetOpenWindowCount;
      end; {try..except}
    end; {if}
end;

procedure TMainForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.ArrangeAll1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.Print1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    begin
      if TWindowBase(TmpForm).IsRegionSelected then
        begin
          PrintScaleDialog1.Options := [poSelection, poWarning];
          PrintScaleDialog1.PrintRange := prSelection;
        end
      else
        PrintScaleDialog1.Options := [poWarning];
      if PrintScaleDialog1.Execute then
        TWindowBase(TmpForm).PrintTheBMP(
            (PrintScaleDialog1.PrintRange = prSelection), CurrPrintScalePercent);
    end; {if}
end;

procedure TMainForm.CopyBitmapToClipBoard1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).CopyBMPToClipBoard;
end;

procedure TMainForm.PrintScale1Click(Sender: TObject);
begin
  if ShowPrintScaleDlg then
    Print1Click(nil); {call print event handler}
end;

procedure TMainForm.CenterBitmap1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).CenterTheBitmap;
end;

procedure TMainForm.CloseFile1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm <> nil then
    TmpForm.Close;
end;

procedure TMainForm.SaveFileAs1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    begin
      if SaveMGFDialog.Execute then
        if SaveMGFDialog.FileName <> '' then
          TWindowBase(TmpForm).SaveFileAs(SaveMGFDialog.FileName);
    end; {if}
end;

procedure TMainForm.SaveFile1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    begin
      if TWindowBase(TmpForm).FileName = '' then
        SaveFileAs1Click(nil)
      else
        TWindowBase(TmpForm).SaveFile;
    end; {if}
end;

procedure TMainForm.OpenFile1Click(Sender: TObject);
begin
  if IsFreeGraphWindowSlot then
    if OpenDialog1.Execute then
      DoCallOpenTheFile(OpenDialog1.FileName);
end;

procedure TMainForm.hlp1Click(Sender: TObject);
begin
   Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TMainForm.SaveAsBMPFile1Click(Sender: TObject);
const
  ErrorMsgStrUnknownFileExt = 'Unknown file type extension. Valid file extenions are "bmp", "jpg" and "jpeg".';
var
  TmpForm : TForm;
  TmpFileNameStr : string;
  TmpFileExtensionStr : string;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    begin
      if SaveBMPDialog.Execute then
        begin
          TmpFileNameStr := SaveBMPDialog.FileName;
          if TmpFileNameStr <> '' then
            begin
              TmpFileExtensionStr := AnsiUpperCase(ExtractFileExt(TmpFileNameStr));
              if TmpFileExtensionStr = '' then
                begin
                  if SaveBMPDialog.FilterIndex = 1 then
                    begin
                      TmpFileNameStr := ChangeFileExt(TmpFileNameStr, '.bmp');
                      TmpFileExtensionStr := '.BMP';
                    end
                  else
                    if SaveBMPDialog.FilterIndex = 2 then
                      begin
                        TmpFileNameStr := ChangeFileExt(TmpFileNameStr, '.jpg');
                        TmpFileExtensionStr := '.JPG';
                      end
                    else
                      begin //an error occured. should never happen
                        MessageDlgCenter(ErrorMsgStrUnknownFileExt, mtError, [mbOK], 0, Self);
                        Exit;
                      end; {else}
                end; {if}
              if (TmpFileExtensionStr = 'BMP') or (TmpFileExtensionStr = '.BMP') then
                TWindowBase(TmpForm).SaveAsPictureFile(TmpFileNameStr, True)
              else
                if (TmpFileExtensionStr = 'JPG') or (TmpFileExtensionStr = '.JPG') or
                   (TmpFileExtensionStr = 'JPEG') or (TmpFileExtensionStr = '.JPEG') then
                  TWindowBase(TmpForm).SaveAsPictureFile(TmpFileNameStr, False)
                else
                  begin
                    MessageDlgCenter(ErrorMsgStrUnknownFileExt, mtError, [mbOK], 0, Self);
                  end; {else}
            end; {if}
        end; {if}
    end; {if}
end;

procedure TMainForm.LabelPenColorButtonClick(Sender: TObject);
var
  NewColor : TColor;
begin
  NewColor := ReturnNewColorComnDlg(LabelPenColorSample.ColorValue, Self);
  LabelPenColorSample.ColorValue := NewColor;
  FToolBarAttribClass.PenColor := NewColor;
end;

procedure TMainForm.ShapeButtonClick(Sender: TObject);
begin
  SelectBitmapRegion1.Checked := false;
  if Sender = ShapeOffButton then FDrawingTool := dtOff
  else if Sender = LineButton then FDrawingTool := dtLine
  else if Sender = RectangleButton then FDrawingTool := dtRectangle
  else if Sender = EllipseButton then FDrawingTool := dtEllipse
  else if Sender = RoundRectButton then FDrawingTool := dtRoundRect
  else if Sender = FreeHandButton then FDrawingTool := dtFreeHand
  else if Sender = FloodFillButton then FDrawingTool := dtFloodFill
  else if Sender = TextButton then FDrawingTool := dtText
  else
    begin
     {error occured, set to dtOff}
      FDrawingTool := dtOff;
      ShapeOffButton.Down := true;
    end; {else}
end;

procedure TMainForm.LabelPenStyleClick(Sender: TObject);
begin
  with FToolBarAttribClass do
    if Sender = ClearPen then PenStyle := psClear
    else if Sender = SolidPen then PenStyle := psSolid
    else if Sender = DashPen then PenStyle := psDash
    else if Sender = DotPen then PenStyle := psDot
    else if Sender = DashDotPen then PenStyle := psDashDot
    else if Sender = DashDotDotPen then PenStyle := psDashDotDot;
end;

procedure TMainForm.LabelPenWidthScrollChange(Sender: TObject);
begin
  LabelPenSize.Caption := IntToStr(LabelPenWidthScroll.Position);
  FToolBarAttribClass.PenWidth := LabelPenWidthScroll.Position;
end;

procedure TMainForm.LabelBrushColorButtonClick(Sender: TObject);
var
  NewColor : TColor;
begin
  NewColor := ReturnNewColorComnDlg(LabelBrushColorSample.ColorValue, Self);
  LabelBrushColorSample.ColorValue := NewColor;
  FToolBarAttribClass.BrushColor := NewColor;
end;

procedure TMainForm.LabelBrushStyleClick(Sender: TObject);
begin
  with FToolBarAttribClass do
    if Sender = ClearBrush then BrushStyle := bsClear
    else if Sender = SolidBrush then BrushStyle := bsSolid
    else if Sender = HorizontalBrush then BrushStyle := bsHorizontal
    else if Sender = VerticalBrush then BrushStyle := bsVertical
    else if Sender = ForwardDiagonalBrush then BrushStyle := bsFDiagonal
    else if Sender = BackwardDiagonalBrush then BrushStyle := bsBDiagonal
    else if Sender = CrossBrush then BrushStyle := bsCross
    else if Sender = DiagonalCrossBrush then BrushStyle := bsDiagCross
end;

procedure TMainForm.FunctionCalculator1Click(Sender: TObject);
begin
  ShowCaculatorDlg;
end;

procedure TMainForm.ResizeLabelsMode1Click(Sender: TObject);
begin
  ResizeLabelsMode1.Checked := not ResizeLabelsMode1.Checked;
end;

procedure TMainForm.OpenTextLabelFontDialog1Click(Sender: TObject);
var
  TmpFont : TFont;
begin
  TmpFont := TFont.Create;
  try
    TmpFont.Assign(FToolBarAttribClass.Font);
    if ShowComnFontDlg(TmpFont, self) then
      begin
        FToolBarAttribClass.Font.Assign(TmpFont);
        UpdateFontFields;
      end; {if}
  finally
    TmpFont.Free;
  end; {try..finally}
end;

procedure TMainForm.FontNameComboChange(Sender: TObject);
begin
  if (FontNameCombo.Text <> FToolBarAttribClass.Font.Name) and
     (FontNameCombo.Text <> '') then
    begin
      FToolBarAttribClass.Font.Name := FontNameCombo.Text;
      UpdateFontSizesCombo;
    end; {if}
end;

procedure TMainForm.FontSizeComboExit(Sender: TObject);
var
  NewSize : integer;
begin
  try
    NewSize := StrToInt(FontSizeCombo.Text);
  except
    NewSize := FToolBarAttribClass.Font.Size;
  end; {try..except}
  if NewSize > 9999 then
    NewSize := 9999;
  if NewSize < -9999 then
    NewSize := -9999;
  FToolBarAttribClass.Font.Size := NewSize;
  FontSizeCombo.Text := IntToStr(FToolBarAttribClass.Font.Size);
end;

procedure TMainForm.FontSizeComboChange(Sender: TObject);
var
  NewSize : integer;
begin
  try
    NewSize := StrToInt(FontSizeCombo.Text);
  except
    NewSize := FToolBarAttribClass.Font.Size;
  end; {try..except}
  if NewSize > 9999 then
    NewSize := 9999;
  if NewSize < -9999 then
    NewSize := -9999;
  FToolBarAttribClass.Font.Size := NewSize;
end;

procedure TMainForm.FontAttribButtonClick(Sender: TObject);
begin
  with FToolBarAttribClass.Font do
    begin
      if Sender = BoldFontButton then
        begin
          if BoldFontButton.Down then
            Style := Style + [fsBold]
          else
            Style := Style - [fsBold];
        end
      else
      if Sender = ItalicFontButton then
        begin
          if ItalicFontButton.Down then
            Style := Style + [fsItalic]
          else
            Style := Style - [fsItalic];
        end
      else
      if Sender = UnderlineFontButton then
        begin
          if UnderlineFontButton.Down then
            Style := Style + [fsUnderline]
          else
            Style := Style - [fsUnderline];
        end; {if}
    end; {with}
end;

procedure TMainForm.ShowHideGraphViewToolBar1Click(Sender: TObject);
begin
  if Assigned(GraphToolBar) then
    GraphToolBar.Visible := not GraphToolBar.Visible;
end;

procedure TMainForm.CenterFuncButtonClick(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowGraph then
    TWindowGraph(TmpForm).CenterFunctionView;
end;

procedure TMainForm.ZoomButtonClick(Sender: TObject);
begin
  if not GeneralOptionsObj.EnableRepTBButtons then
    DoZoomButtonHit(Sender);
end;

procedure TMainForm.ZoomAxisButtonClick(Sender: TObject);
begin
  if not GeneralOptionsObj.EnableRepTBButtons then
    DoZoomAxisButtonHit(Sender);
end;

procedure TMainForm.ScrollButtonClick(Sender: TObject);
begin
  if not GeneralOptionsObj.EnableRepTBButtons then
    DoScrollButtonHit(Sender);
end;

procedure TMainForm.PageButtonClick(Sender: TObject);
begin
  if not GeneralOptionsObj.EnableRepTBButtons then
    DoPageButtonHit(Sender);
end;

procedure TMainForm.RotateButtonClick(Sender: TObject);
begin
  if not GeneralOptionsObj.EnableRepTBButtons then
    DoRotateButtonHit(Sender);
end;

procedure TMainForm.StatusBarResize(Sender: TObject);
var
  NewPanelWidth : integer;
begin
  if Width <= 450 then
    begin
      StatusBar.Panels[0].Width := 150;
      StatusBar.Panels[1].Width := 150;
      StatusBar.Panels[2].Width := 150;
    end
  else
    begin
      NewPanelWidth := Width div 3;
      StatusBar.Panels[0].Width := NewPanelWidth;
      StatusBar.Panels[1].Width := NewPanelWidth;
      StatusBar.Panels[2].Width := NewPanelWidth;
    end; {else}
end;

procedure TMainForm.ShowShapeToolBar1Click(Sender: TObject);
begin
  if Assigned(LabelShapeToolBar) then
    LabelShapeToolBar.Visible := not LabelShapeToolBar.Visible;
end;

procedure TMainForm.ShowOptionsDlgClick(Sender: TObject);
var
  TmpForm : TForm;
  ShowStatusBarPanel : boolean;
begin
  ShowStatusBarPanel := (Sender = StatusBar);
  if DisplayOptionsDlg(ShowStatusBarPanel, GeneralOptionsObj, StatusLineObj,
                       HotKey2DObj, HotKeyPolarObj, HotKey3DObj) then
    begin
      UpdateOptionValues;
      TmpForm := ActiveMDIChild;
      if TmpForm is TWindowBase then
        TWindowBase(TmpForm).DisplayStatusMessage;
      SaveOptionsToIniFiles;
    end; {if}
end;

procedure TMainForm.ColorDialog1Show(Sender: TObject);
begin
  try
    SetCommonDlgDefPosOnShow(ColorDialog1, FCenterColorDlgOnForm);
  except
  end; {try..except}
end;

procedure TMainForm.FontDialog1Show(Sender: TObject);
begin
  try
    SetCommonDlgDefPosOnShow(FontDialog1, FCenterFontDlgOnForm);
  except
  end; {try..except}
end;

procedure TMainForm.UpdateOptionValues;
begin
  //GeneralOptionsObj
  if Assigned(GraphToolBar) and Assigned(LabelShapeToolBar) then
    begin
      if GeneralOptionsObj.FlatToolBars then
        begin
          GraphToolBar.Flat := true;
          LabelShapeToolBar.Flat := true;
        end
      else
        begin
          GraphToolBar.Flat := false;
          LabelShapeToolBar.Flat := false;
        end; {else}
    end; {if}
  RePositionCommonDlgs := GeneralOptionsObj.CenterCommonDlgs;
  DefaultDlgPosition := GeneralOptionsObj.CenterDlgsOnPosition;
  //StatusLineObj
  StatusBar.Visible := StatusLineObj.ShowStatusLine;
end;

procedure TMainForm.ReadOptionsFromIniFiles;
var
  TmpFileStr : string;
  TmpIniFile : TMemIniFile;
{---------------------------------}
procedure ReadTrigFixupFromIniFile;
const
  sct_TrigFixup = 'TrigFixup';
    key_TrigFixupType = 'TrigFixupType';
      enu_tfNormal = 'tfNormal';
      enu_tfThou = 'tfThou';
      enu_tfTenThou = 'tfTenThou'; //default
      enu_tfHundThou = 'tfHundThou';
      enu_tfMill = 'tfMill';
      enu_tfTenMill = 'tfTenMill';
    key_TrigRequireExact = 'TrigRequireExact';
var
  TmpStr : string;
  TrigFixupType : TMathTrigFixupType;
  TrigRequireExact : boolean;
begin {procedure ReadTrigFixupFromIniFile;}
  try
    TmpStr := TmpIniFile.ReadString(sct_TrigFixup, key_TrigFixupType, enu_tfTenThou);
    if TmpStr = enu_tfNormal then TrigFixupType := tfNormal else
    if TmpStr = enu_tfThou then TrigFixupType := tfThou else
    if TmpStr = enu_tfTenThou then TrigFixupType := tfTenThou else
    if TmpStr = enu_tfHundThou then TrigFixupType := tfHundThou else
    if TmpStr = enu_tfMill then TrigFixupType := tfMill else
    if TmpStr = enu_tfTenMill then TrigFixupType := tfTenMill else
      TrigFixupType := tfTenThou;
    TrigRequireExact := TmpIniFile.ReadBool(sct_TrigFixup, key_TrigRequireExact, false);
    SetGlobalMathTrigFixup(TrigFixupType, TrigRequireExact);
  except
  end; {try..except}
end; {procedure ReadTrigFixupFromIniFile;}
{---------------------------------}
begin {procedure TMainForm.ReadOptionsFromIniFiles;}
  try
    GraphTBarIniVisible := true;
    LabelTBarIniVisible := false;
    TmpFileStr := ExtractFilePath(ParamStr(0)) + IniFileNameString;
    if FileExists(TmpFileStr) then
      begin
        TmpIniFile := TMemIniFile.Create(TmpFileStr);
        try
          AllowIniFileChanges := TmpIniFile.ReadBool(sec_CanSaveOptions, key_AllowIniFileChanges, true);
          GraphTBarIniVisible := TmpIniFile.ReadBool(sec_ToolBarVisibility, key_ShowGraphToolBar, true);
          LabelTBarIniVisible := TmpIniFile.ReadBool(sec_ToolBarVisibility, key_ShowLabelToolBar, False);
          ReadTrigFixupFromIniFile;
          if ReadDefaultFontFromIni(TmpIniFile) then
          if GeneralOptionsObj.ReadFromIniFile(TmpIniFile) then
          if StatusLineObj.ReadFromIniFile(TmpIniFile) then
          if HotKey2DObj.ReadFromIniFile(TmpIniFile) then
          if HotKeyPolarObj.ReadFromIniFile(TmpIniFile) then
            HotKey3DObj.ReadFromIniFile(TmpIniFile);
        finally
          TmpIniFile.Free;
        end; {try..finally}
      end; {if}
  except
  end; {try..except}
end; {procedure TMainForm.ReadOptionsFromIniFiles;}

procedure TMainForm.SaveOptionsToIniFiles;
var
  TmpFileStr : string;
  TmpIniFile : TMemIniFile;
begin
  try
    TmpFileStr := ExtractFilePath(ParamStr(0)) + IniFileNameString;
    if AllowIniFileChanges and FileExists(TmpFileStr) then
      begin
        TmpIniFile := TMemIniFile.Create(TmpFileStr);
        try
          if WriteDefaultFontToIni(TmpIniFile) then
          if GeneralOptionsObj.SaveToIniFile(TmpIniFile) then
          if StatusLineObj.SaveToIniFile(TmpIniFile) then
          if HotKey2DObj.SaveToIniFile(TmpIniFile) then
          if HotKeyPolarObj.SaveToIniFile(TmpIniFile) then
            HotKey3DObj.SaveToIniFile(TmpIniFile);
          TmpIniFile.UpdateFile;
        finally
          TmpIniFile.Free;
        end; {try..finally}
      end; {if}
  except
  end; {try..except}
end;

procedure TMainForm.SaveToolBarVisToIniFiles;
var
  TmpFileStr : string;
  TmpIniFile : TMemIniFile;
begin
  try
    if Assigned(GraphToolBar) and Assigned(LabelShapeToolBar) then
    if (GraphTBarIniVisible <> GraphToolBar.Visible) or
       (LabelTBarIniVisible <> LabelShapeToolBar.Visible) then
      begin
        TmpFileStr := ExtractFilePath(ParamStr(0)) + IniFileNameString;
        if AllowIniFileChanges and FileExists(TmpFileStr) then
          begin
            TmpIniFile := TMemIniFile.Create(TmpFileStr);
            try
              TmpIniFile.WriteBool(sec_ToolBarVisibility, key_ShowGraphToolBar, GraphToolBar.Visible);
              TmpIniFile.WriteBool(sec_ToolBarVisibility, key_ShowLabelToolBar, LabelShapeToolBar.Visible);
              TmpIniFile.UpdateFile;
            finally
              TmpIniFile.Free;
            end; {try..finally}
          end; {if}
      end; {if}
  except
  end; {try.except}
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if Assigned(RepeatingToolBarClick) and Assigned(RepeatingToolBarSender) then
    begin
      if Timer1.Interval <> Cardinal(GeneralOptionsObj.RepeatRate) then
        begin
          Timer1.Enabled := False;
          Timer1.Interval := GeneralOptionsObj.RepeatRate;
          RepeatingToolBarClick(RepeatingToolBarSender);
          Timer1.Enabled := true;
        end
      else
        RepeatingToolBarClick(RepeatingToolBarSender);
    end
  else
    Timer1.Enabled := False;
end;

procedure TMainForm.ZoomButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  if GeneralOptionsObj.EnableRepTBButtons then
    begin
      RepeatingToolBarClick := DoZoomButtonHit;
      RepeatingToolBarSender := Sender;
      DoZoomButtonHit(Sender);
      Timer1.Interval := GeneralOptionsObj.RepeatDelay;
      Timer1.Enabled := true;
    end; {if}
end;

procedure TMainForm.RepeatingButtonMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
end;

procedure TMainForm.ZoomAxisButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  if GeneralOptionsObj.EnableRepTBButtons then
    begin
      RepeatingToolBarClick := DoZoomAxisButtonHit;
      RepeatingToolBarSender := Sender;
      DoZoomAxisButtonHit(Sender);
      Timer1.Interval := GeneralOptionsObj.RepeatDelay;
      Timer1.Enabled := true;
    end; {if}
end;

procedure TMainForm.ScrollButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  if GeneralOptionsObj.EnableRepTBButtons then
    begin
      RepeatingToolBarClick := DoScrollButtonHit;
      RepeatingToolBarSender := Sender;
      DoScrollButtonHit(Sender);
      Timer1.Interval := GeneralOptionsObj.RepeatDelay;
      Timer1.Enabled := true;
    end; {if}
end;

procedure TMainForm.PageButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  if GeneralOptionsObj.EnableRepTBButtons then
    begin
      RepeatingToolBarClick := DoPageButtonHit;
      RepeatingToolBarSender := Sender;
      DoPageButtonHit(Sender);
      Timer1.Interval := GeneralOptionsObj.RepeatDelay;
      Timer1.Enabled := true;
    end; {if}
end;

procedure TMainForm.RotateButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Timer1.Enabled := False;
  RepeatingToolBarClick := nil;
  RepeatingToolBarSender := nil;
  if GeneralOptionsObj.EnableRepTBButtons then
    begin
      RepeatingToolBarClick := DoRotateButtonHit;
      RepeatingToolBarSender := Sender;
      DoRotateButtonHit(Sender);
      Timer1.Interval := GeneralOptionsObj.RepeatDelay;
      Timer1.Enabled := true;
    end; {if}
end;

procedure TMainForm.RepeatingButtonMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  ShouldStopTimer : boolean;
begin
  ShouldStopTimer := false;
  if (Sender is TToolButton) then
    begin
      if (ssLeft in Shift) or (ssRight in Shift) or (ssMiddle in Shift) then
        begin
          if (X < 0) or (Y < 0) or (Y >= TToolBar(Sender).Height) or
                                   (X >= TToolBar(Sender).Width) then
            ShouldStopTimer := true;
        end; {if}
    end
  else
    ShouldStopTimer := true;
  if ShouldStopTimer then
    begin
      Timer1.Enabled := False;
      RepeatingToolBarClick := nil;
      RepeatingToolBarSender := nil;
    end; {if}
end;

procedure TMainForm.DoPageButtonHit(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindow2D then
    begin
      with TWindow2D(TmpForm) do
        begin
          if Sender = PageUpButton then PageViewUp else
          if Sender = PageDownButton then PageViewDown else
          if Sender = PageLeftButton then PageViewLeft else
          if Sender = PageRightButton then PageViewRight;
        end; {with}
    end
  else
    if TmpForm is TWindowPolar then
      begin
        with TWindowPolar(TmpForm) do
          begin
            if Sender = PageUpButton then PageViewUp else
            if Sender = PageDownButton then PageViewDown else
            if Sender = PageLeftButton then PageViewLeft else
            if Sender = PageRightButton then PageViewRight;
          end; {with}
      end; {else}
end;

procedure TMainForm.DoRotateButtonHit(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindow3D then
    begin
      with TWindow3D(TmpForm) do
        begin
          if Sender = RotateUpButton then RotateNegX else
          if Sender = RotateDownButton then RotatePosX else
          if Sender = RotateLeftButton then RotateNegY else
          if Sender = RotateRightButton then RotatePosY else
          if Sender = RotateZLeftButton then RotatePosZ else
          if Sender = RotateZRightButton then RotateNegZ;
        end; {with}
    end; {if}
end;

procedure TMainForm.DoScrollButtonHit(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindow2D then
    begin
      with TWindow2D(TmpForm) do
        begin
          if Sender = ScrollUpButton then ScrollViewUp else
          if Sender = ScrollDownButton then ScrollViewDown else
          if Sender = ScrollLeftButton then ScrollViewLeft else
          if Sender = ScrollRightButton then ScrollViewRight;
        end; {with}
    end
  else
    if TmpForm is TWindowPolar then
      begin
        with TWindowPolar(TmpForm) do
          begin
            if Sender = ScrollUpButton then ScrollViewUp else
            if Sender = ScrollDownButton then ScrollViewDown else
            if Sender = ScrollLeftButton then ScrollViewLeft else
            if Sender = ScrollRightButton then ScrollViewRight;
          end; {with}
      end; {else}
end;

procedure TMainForm.DoZoomAxisButtonHit(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindow2D then
    begin
      with TWindow2D(TmpForm) do
        begin
          if Sender = ZoomXInButton then ZoomInXAxis else
          if Sender = ZoomXOutButton then ZoomOutXAxis else
          if Sender = ZoomYInButton then ZoomInYAxis else
          if Sender = ZoomYOutButton then ZoomOutYAxis;
        end; {with}
    end; {if}
end;

procedure TMainForm.DoZoomButtonHit(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowGraph then
    begin
      if Sender = ZoomInButton then
        TWindowGraph(TmpForm).ZoomIn
      else
        if Sender = ZoomOutButton then
          TWindowGraph(TmpForm).ZoomOut;
    end; {if}
end;

procedure TMainForm.PrintScaleDialog1Show(Sender: TObject);
begin
  try
    SetCommonDlgDefPosOnShow(PrintScaleDialog1, Self);
  except
  end; {try..except}
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
begin
  //terminate all threads to prepare for shutting down the app
  for I := MDIChildCount-1 downto 0 do
    TWindowBase(MDIChildren[I]).TerminateAllThreads;
  for I := MDIChildCount-1 downto 0 do
    TWindowBase(MDIChildren[I]).WaitForTermAllThreads;
  //save ini file stttings
  SaveToolBarVisToIniFiles;
end;

procedure TMainForm.RedrawWindow1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).ReStartGraphThread;
end;

procedure TMainForm.StopDrawingWindow1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).WaitForTermAllThreads;
end;

procedure TMainForm.SelectBitmapRegion1Click(Sender: TObject);
begin
  SelectBitmapRegion1.Checked := not SelectBitmapRegion1.Checked;
  ShapeOffButton.Down := true;
  if SelectBitmapRegion1.Checked = true then
    FDrawingTool := dtSelectRegion
  else
    FDrawingTool := dtOff;
end;

procedure TMainForm.BitmapRegionDialog1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).ShowSelectRegionDlg;
end;

procedure TMainForm.BitmapSize1Click(Sender: TObject);
var
  TmpForm : TForm;
begin
  TmpForm := ActiveMDIChild;
  if TmpForm is TWindowBase then
    TWindowBase(TmpForm).ReSizeTheBMP;
end;

end.
