unit HotKey2D;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  MathCalc, MathFunc, inifiles, HotKey, Vw2DObj;

type
  THotKey2DObj = class(THotKeyObj)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    function ReadFromIniFile(TheIniFile : TMemIniFile) : boolean;
    function SaveToIniFile(TheIniFile : TMemIniFile) : boolean;
    function Calc2DZoomIn(var TheViewZoomVar : TMathFloat) : boolean;
    function Calc2DZoomOut(var TheViewZoomVar : TMathFloat) : boolean;
  end; {THotKey2DObj}


implementation

{ THotKey2DObj }

{---------------------------------------------------------------------}

function THotKey2DObj.Calc2DZoomIn(var TheViewZoomVar: TMathFloat): boolean;
begin
  Result := DoCalcNewZoomIn(TheViewZoomVar, Max2DViewZoom);
end;

{---------------------------------------------------------------------}

function THotKey2DObj.Calc2DZoomOut(var TheViewZoomVar: TMathFloat): boolean;
begin
  Result := DoCalcNewZoomOut(TheViewZoomVar, Min2DViewZoom);
end;

{---------------------------------------------------------------------}

function THotKey2DObj.ReadFromIniFile(TheIniFile: TMemIniFile): boolean;
begin
  Result := DoReadFromIniFile(TheIniFile, '2D');
end;

{---------------------------------------------------------------------}

function THotKey2DObj.SaveToIniFile(TheIniFile: TMemIniFile): boolean;
begin
  Result := DoSaveToIniFile(TheIniFile, '2D');
end;

{---------------------------------------------------------------------}

end.
