unit Imag2d;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, Vw2dObj, Set2dObj, PtImList, PtTh2d;

const
  Max2DFuncCount = PtTh2d.Max2DFuncCount;

type
  TImage2D = class(TPlotImageFuncList)
  private
    { Private declarations }
    function GetView2DZoomObj : TView2DZoomObj;
    function GetSetting2DObj : TSetting2DObj;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property View2DZoomObj : TView2DZoomObj read GetView2DZoomObj;
    property Setting2DObj : TSetting2DObj read GetSetting2DObj;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end; {TImage2D}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Math', [TImage2D]);
end;

{ TImage2D }

constructor TImage2D.Create(AOwner: TComponent);
begin
  inherited;
  PlotThread := TPlotThread2D.Create;
  AssignEventsPlotThread(PlotThread);
end;

destructor TImage2D.Destroy;
begin
  WaitForTermAllThreads;
  PlotThread.free;
  inherited;
end;

function TImage2D.GetSetting2DObj: TSetting2DObj;
begin
  Result := TPlotThread2D(PlotThread).Setting2DObj;
end;

function TImage2D.GetView2DZoomObj: TView2DZoomObj;
begin
  Result := TPlotThread2D(PlotThread).View2DZoomObj;
end;

end.
