unit Imag3d;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, Vw3dObj, Set3dObj, PtImList, PtTh3d;

const
  Max3DFuncCount = PtTh3d.Max3DFuncCount;

type
  TImage3D = class(TPlotImageFuncList)
  private
    { Private declarations }
    function GetView3DZoomObj : TView3DZoomObj;
    function GetSetting3DObj : TSetting3DObj;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property View3DZoomObj : TView3DZoomObj read GetView3DZoomObj;
    property Setting3DObj : TSetting3DObj read GetSetting3DObj;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end; {TImage3D}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Math', [TImage3D]);
end;

{ TImage3D }

constructor TImage3D.Create(AOwner: TComponent);
begin
  inherited;
  PlotThread := TPlotThread3D.Create;
  AssignEventsPlotThread(PlotThread);
end;

destructor TImage3D.Destroy;
begin
  WaitForTermAllThreads;
  PlotThread.free;
  inherited;
end;

function TImage3D.GetSetting3DObj: TSetting3DObj;
begin
  Result := TPlotThread3D(PlotThread).Setting3DObj;
end;

function TImage3D.GetView3DZoomObj: TView3DZoomObj;
begin
  Result := TPlotThread3D(PlotThread).View3DZoomObj;
end;

end.
