unit ImagPict;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, PtImage, PtThPict;

type
  TImagePicture = class(TPlotImageBox)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end; {TImagePicture}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Math', [TImagePicture]);
end;

{ TImagePicture }

constructor TImagePicture.Create(AOwner: TComponent);
begin
  inherited;
  PlotThread := TPlotThreadPicture.Create;
  AssignEventsPlotThread(PlotThread);
end;

destructor TImagePicture.Destroy;
begin
  WaitForTermAllThreads;
  PlotThread.free;
  inherited;
end;

end.
 