unit ImagPolr;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, VwPoObj, SetPoObj, PtImList, PtThPolr;

const
  MaxPolarFuncCount = PtThPolr.MaxPolarFuncCount;

type
  TImagePolar = class(TPlotImageFuncList)
  private
    { Private declarations }
    function GetViewPolarZoomObj : TViewPolarZoomObj;
    function GetSettingPolarObj : TSettingPolarObj;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property ViewPolarZoomObj : TViewPolarZoomObj read GetViewPolarZoomObj;
    property SettingPolarObj : TSettingPolarObj read GetSettingPolarObj;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end; {TImagePolar}

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Math', [TImagePolar]);
end;

{ TImagePolar }

constructor TImagePolar.Create(AOwner: TComponent);
begin
  inherited;
  PlotThread := TPlotThreadPolar.Create;
  AssignEventsPlotThread(PlotThread);
end;

destructor TImagePolar.Destroy;
begin
  WaitForTermAllThreads;
  PlotThread.free;
  inherited;
end;

function TImagePolar.GetSettingPolarObj: TSettingPolarObj;
begin
  Result := TPlotThreadPolar(PlotThread).SettingPolarObj;
end;

function TImagePolar.GetViewPolarZoomObj: TViewPolarZoomObj;
begin
  Result := TPlotThreadPolar(PlotThread).ViewPolarZoomObj;
end;

end.
