unit LbGlobal;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  Graphics, Forms, GrDraw, DrawObjs;

function ModifyLabelObj(LabelObj : TDrawBaseClass;
                        const TheBmpAttribRec : TBitmapAttribRec;
                        TheBitmap : TBitmap; TheCenterOnForm : TForm) : boolean;

implementation

uses
  DFillDlg, DFreeDlg, DRectDlg, DLineDlg, DTextDlg;

function ModifyLabelObj(LabelObj : TDrawBaseClass;
                        const TheBmpAttribRec : TBitmapAttribRec;
                        TheBitmap : TBitmap; TheCenterOnForm : TForm) : boolean;
begin {function ModifyLabelObj}
  Result := false;
  try
    if LabelObj is TDrawFloodFill then
      Result := ModifyFloodFillAttribDlg(TDrawFloodFill(LabelObj), TheBmpAttribRec, TheCenterOnForm)
    else
    if LabelObj is TDrawFreeHand then
      Result := ModifyFreeHandAttribDlg(TDrawFreeHand(LabelObj), TheBmpAttribRec, TheCenterOnForm)
    else
    if LabelObj is TDrawInclosedShape then
      Result := ModifyInclosedAttribDlg(TDrawInclosedShape(LabelObj), TheBmpAttribRec, TheCenterOnForm)
    else
    if LabelObj is TDrawLine then
      Result := ModifyLineAttribDlg(TDrawLine(LabelObj), TheBmpAttribRec, TheCenterOnForm)
    else
    if LabelObj is TDrawText then
      Result := ModifyTextAttribDlg(TDrawText(LabelObj), TheBitmap,
                                    TheBmpAttribRec, TheCenterOnForm)
  except
    Result := False;
  end; {try..except}
end; {function ModifyLabelObj}

end.
