unit Prntscal;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, CentrDlg;

type
  TPrintScaleDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    EPercent: TSpinEdit;
    Label1: TLabel;
    BPrint: TBitBtn;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CurrPrintScalePercent : integer = 100;

function ShowPrintScaleDlg : boolean;

implementation

{$R *.DFM}

function ShowPrintScaleDlg : boolean;
  {Returns true if print button}
var
  PrintScaleDlg: TPrintScaleDlg;
  ModalR : integer;
begin {function ShowPrintScaleDlg;}
  Result := false;
  PrintScaleDlg := TPrintScaleDlg.Create(Application);
  try
    SetDlgDefaultPos(PrintScaleDlg, nil);
    PrintScaleDlg.EPercent.Value := CurrPrintScalePercent;
    ModalR := PrintScaleDlg.ShowModal;
    if (ModalR = IDOK)or(ModalR = IDYes) then
      begin
        CurrPrintScalePercent := PrintScaleDlg.EPercent.Value;
        Result := (ModalR = IDYes);
      end; {if}
  finally
    PrintScaleDlg.free;
  end; {try..finally}
end; {function ShowPrintScaleDlg;}

procedure TPrintScaleDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
  FormKeyPressSpinEditClose(self, Key);
end;

end.
