unit PtImGraf;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, graphics, PtImage, PtThGraf, SetGraph;

type
  TPlotImageGraph = class(TPlotImageBox)
  private
    { Private declarations }
    function GetAnimatedPlotting : boolean;
    function GetAnimationDelay : integer;
    procedure SetAnimatedPlotting(TheAnimatedPlotting : boolean);
    procedure SetAnimationDelay(TheAnimationDelay : integer);
    function GetSettingGrBGPictObj : TSettingGrBGPictObj;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property AnimatedPlotting : boolean read GetAnimatedPlotting write SetAnimatedPlotting;
    property AnimationDelay : integer read GetAnimationDelay write SetAnimationDelay; //in milliseconds
    property SettingGrBGPictObj : TSettingGrBGPictObj read GetSettingGrBGPictObj;
  end; {TPlotImageGraph}

implementation

{ TPlotImageGraph }

function TPlotImageGraph.GetAnimatedPlotting: boolean;
begin
  Assert((PlotThread is TPlotThreadGraph), 'PlotThread is not a TPlotThreadGraph');
  Result := TPlotThreadGraph(PlotThread).AnimatedPlotting;
end;

function TPlotImageGraph.GetAnimationDelay: integer;
begin
  Assert((PlotThread is TPlotThreadGraph), 'PlotThread is not a TPlotThreadGraph');
  Result := TPlotThreadGraph(PlotThread).AnimationDelay;
end;

function TPlotImageGraph.GetSettingGrBGPictObj: TSettingGrBGPictObj;
begin
  Assert((PlotThread is TPlotThreadGraph), 'PlotThread is not a TPlotThreadGraph');
  Result := TPlotThreadGraph(PlotThread).SettingGrBGPictObj;
end;

procedure TPlotImageGraph.SetAnimatedPlotting(
  TheAnimatedPlotting: boolean);
begin
  Assert((PlotThread is TPlotThreadGraph), 'PlotThread is not a TPlotThreadGraph');
  TPlotThreadGraph(PlotThread).AnimatedPlotting := TheAnimatedPlotting;
end;

procedure TPlotImageGraph.SetAnimationDelay(TheAnimationDelay: integer);
begin
  Assert((PlotThread is TPlotThreadGraph), 'PlotThread is not a TPlotThreadGraph');
  TPlotThreadGraph(PlotThread).AnimationDelay := TheAnimationDelay;
end;

end.
