unit PtImList;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  classes, Graphics, FuncObj, PtImGraf, PtThList;

type
  TPlotImageFuncList = class(TPlotImageGraph)
  private
    { Private declarations }
    function GetFuncList : TList;
  protected
    { Protected declarations }
  public
    { Public declarations }
    property FuncList : TList read GetFuncList;
    procedure AddNewFuncListObj(TheFunctionObj : TBaseFuncObj);
    procedure ClearFuncListObj;
    function IsFreeFuncListObjSlot : boolean;
    function GetNextDefaultColor : TColor;
  end; {TPlotImageFuncList}

implementation

{---------------------------------------------------------------------}

{ TPlotImageFuncList }

procedure TPlotImageFuncList.AddNewFuncListObj(
  TheFunctionObj: TBaseFuncObj);
begin {procedure TPlotImageFuncList.AddNewFuncListObj}
  Assert((PlotThread is TPlotThreadFuncList), 'PlotThread is not TPlotThreadFuncList');
  TPlotThreadFuncList(PlotThread).AddNewFuncListObj(TheFunctionObj);
end; {procedure TPlotImageFuncList.AddNewFuncListObj}

{---------------------------------------------------------------------}

procedure TPlotImageFuncList.ClearFuncListObj;
begin {procedure TPlotImageFuncList.ClearFuncListObj;}
  Assert((PlotThread is TPlotThreadFuncList), 'PlotThread is not TPlotThreadFuncList');
  TPlotThreadFuncList(PlotThread).ClearFuncListObj;
end; {procedure TPlotImageFuncList.ClearFuncListObj;}

{---------------------------------------------------------------------}

function TPlotImageFuncList.GetFuncList: TList;
begin {function TPlotImageFuncList.GetFuncList}
  Assert((PlotThread is TPlotThreadFuncList), 'PlotThread is not TPlotThreadFuncList');
  Result := TPlotThreadFuncList(PlotThread).FuncList;
end; {function TPlotImageFuncList.GetFuncList}

{---------------------------------------------------------------------}

function TPlotImageFuncList.GetNextDefaultColor : TColor;
begin {function TPlotImageFuncList.GetNextDefaultColor}
  Assert((PlotThread is TPlotThreadFuncList), 'PlotThread is not TPlotThreadFuncList');
  Result := TPlotThreadFuncList(PlotThread).GetNextDefaultColor;
end; {function TPlotImageFuncList.GetNextDefaultColor}

{---------------------------------------------------------------------}

function TPlotImageFuncList.IsFreeFuncListObjSlot: boolean;
begin {function TPlotImageFuncList.IsFreeFuncListObjSlot}
  Assert((PlotThread is TPlotThreadFuncList), 'PlotThread is not TPlotThreadFuncList');
  Result := TPlotThreadFuncList(PlotThread).IsFreeFuncListObjSlot;
end; {function TPlotImageFuncList.IsFreeFuncListObjSlot}

{---------------------------------------------------------------------}

end.
