unit PtThPict;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  Graphics, PtThread, FileSave;

type
  TPlotThreadPicture = class(TPlotThread)
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure DoAssignFieldObjects; override; //this method is not thread safe
    function WriteFileToDisk(const FString : string) : boolean; override;
    function GetIsGraphThreadRunning : boolean; override;
    function GetPlotTypeString : string; override;
  public
    { Public declarations }
    constructor Create;
    destructor Destroy; override;
    procedure ReStartGraphThread; override;
    procedure TerminateGraphThread; override;
    procedure WaitForTermGraphThread; override;
    procedure InitalizeNew(TheColorDepth : TPixelFormat;
                           TheDefaultBmpWidth, TheDefaultBmpHeight : integer); override;
    function InitalizeFromFile(TheColorDepth : TPixelFormat;
                               const TheFileName : string;
                               ReadGraphFile : TReadGraphFile) : boolean; override;
  end; {TPlotThreadPicture}

implementation

{ TPlotThreadPicture }

constructor TPlotThreadPicture.Create;
begin
  inherited;

end;

destructor TPlotThreadPicture.Destroy;
begin

  inherited;
end;

procedure TPlotThreadPicture.DoAssignFieldObjects;
begin
  SettingBmpAttribsObj.SetAllDidChange(false); //all assignments are done
  inherited; //do i want to call this 
end;

function TPlotThreadPicture.GetIsGraphThreadRunning: boolean;
begin
  Result := false;
end;

function TPlotThreadPicture.GetPlotTypeString: string;
begin
  Result := ''; ////////////////// code here /////////////////
end;

function TPlotThreadPicture.InitalizeFromFile(TheColorDepth: TPixelFormat;
  const TheFileName : string; ReadGraphFile: TReadGraphFile): boolean;
begin
  Result := false; ////////////////// code here /////////////////
  FFileName := TheFileName;
end;

procedure TPlotThreadPicture.InitalizeNew(TheColorDepth: TPixelFormat;
  TheDefaultBmpWidth, TheDefaultBmpHeight: integer);
begin
  inherited;
end;

procedure TPlotThreadPicture.ReStartGraphThread;
begin
  inherited;

end;

procedure TPlotThreadPicture.TerminateGraphThread;
begin
  inherited;

end;

procedure TPlotThreadPicture.WaitForTermGraphThread;
begin
  inherited;

end;

function TPlotThreadPicture.WriteFileToDisk(
  const FString: string): boolean;
begin
  Result := false; ////////////////// code here /////////////////
end;

end.
