unit Selected;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, CentrDlg;

type
  TUseSelectedRectDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    SelectedButton: TRadioButton;
    AllButton: TRadioButton;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function PromptUseSelected(IsCopyClipboard : boolean;
                           var UseSelected : boolean) : boolean;

implementation

{$R *.DFM}

function PromptUseSelected(IsCopyClipboard : boolean;
                           var UseSelected : boolean) : boolean;
var
  UseSelectedRectDlg: TUseSelectedRectDlg;
begin {function PromptUseSelected}
  Result := false;
  UseSelectedRectDlg := TUseSelectedRectDlg.Create(Application);
  try
    SetDlgDefaultPos(UseSelectedRectDlg, nil);
    if IsCopyClipboard then
      UseSelectedRectDlg.Caption := 'Area to Paste to Clipboard'
    else
      UseSelectedRectDlg.Caption := 'Area to Save to File';
    if UseSelectedRectDlg.ShowModal = IDOK then
      Result := True;
    UseSelected := UseSelectedRectDlg.SelectedButton.Checked;
  finally
    UseSelectedRectDlg.Free;
  end; {try..finally}
end; {function PromptUseSelected}


end.
