unit Set2ddlg;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons, DefFont,
  StdCtrls, Spin, sysutils, Clsample, Dialogs, ComnDlgs, CentrDlg,
  editmath, ExtCtrls, FloatStr, MathCalc, MathFunc, ComCtrls, Set2dObj;

type
  TSettings2DDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    PageControl1: TPageControl;
    AxisLinesTab: TTabSheet;
    TickMarksTab: TTabSheet;
    LabelsTab: TTabSheet;
    XAxisLineBox: TGroupBox;
    XAxisColorSample: TColorSample;
    Label2: TLabel;
    XAxisWidthLabel: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    XAxisColorButton: TButton;
    EXAxisWidth: TScrollBar;
    XAxisLineGroupBox: TGroupBox;
    XSolidPen: TSpeedButton;
    XDashPen: TSpeedButton;
    XDotPen: TSpeedButton;
    XDashDotPen: TSpeedButton;
    XDashDotDotPen: TSpeedButton;
    EXShowAxisLines: TCheckBox;
    EXLimitLoAxis: TEditMathConst;
    EXLimitHiAxis: TEditMathConst;
    YAxisLineBox: TGroupBox;
    YAxisColorSample: TColorSample;
    Label1: TLabel;
    YAxisWidthLabel: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    YAxisColorButton: TButton;
    EYAxisWidth: TScrollBar;
    YAxisLineGroupBox: TGroupBox;
    YSolidPen: TSpeedButton;
    YDashPen: TSpeedButton;
    YDotPen: TSpeedButton;
    YDashDotPen: TSpeedButton;
    YDashDotDotPen: TSpeedButton;
    EYShowAxisLines: TCheckBox;
    EYLimitLoAxis: TEditMathConst;
    EYLimitHiAxis: TEditMathConst;
    BackColorBox: TGroupBox;
    BackColorSample: TColorSample;
    BackColorButton: TButton;
    XTickMarkBox: TGroupBox;
    Label13: TLabel;
    XTMColorSample: TColorSample;
    Label14: TLabel;
    XTMSizeLabel: TLabel;
    XTMColorButton: TButton;
    EXTickMarkLength: TScrollBar;
    EXTickMarkInc: TEditMathConst;
    YTickMarkBox: TGroupBox;
    Label8: TLabel;
    YTMColorSample: TColorSample;
    Label9: TLabel;
    YTMSizeLabel: TLabel;
    YTMColorButton: TButton;
    EYTickMarkLength: TScrollBar;
    EYTickMarkInc: TEditMathConst;
    XTMLabelBox: TGroupBox;
    TextFieldXTMLabelDP: TLabel;
    EXShowTMLabels: TCheckBox;
    EXTMLabelDecPlaces: TSpinEdit;
    XTMLabelFontButton: TButton;
    EXShowTMLabelPlus: TCheckBox;
    EXShowTMLabelComa: TCheckBox;
    EXTMLabelFormat: TComboBox;
    YTMLabelBox: TGroupBox;
    TextFieldYTMLabelDP: TLabel;
    EYShowTMLabels: TCheckBox;
    EYTMLabelDecPlaces: TSpinEdit;
    YTMLabelFontButton: TButton;
    EYShowTMLabelPlus: TCheckBox;
    EYShowTMLabelComa: TCheckBox;
    EYTMLabelFormat: TComboBox;
    XGridLineStyleGroupBox: TGroupBox;
    XGridSolidLine: TSpeedButton;
    XGridDashLine: TSpeedButton;
    XGridDotLine: TSpeedButton;
    XGridDashDotLine: TSpeedButton;
    XGridDashDotDotLine: TSpeedButton;
    XTMTypeGroupBox: TGroupBox;
    EXNone: TRadioButton;
    EXTickMarks: TRadioButton;
    EXGridMarks: TRadioButton;
    EXGridLines: TRadioButton;
    YGridLineStyleGroupBox: TGroupBox;
    YGridSolidLine: TSpeedButton;
    YGridDashLine: TSpeedButton;
    YGridDotLine: TSpeedButton;
    YGridDashDotLine: TSpeedButton;
    YGridDashDotDotLine: TSpeedButton;
    YTMTypeGroupBox: TGroupBox;
    EYNone: TRadioButton;
    EYTickMarks: TRadioButton;
    EYGridMarks: TRadioButton;
    EYGridLines: TRadioButton;
    Label3: TLabel;
    Label5: TLabel;
    procedure BackColorButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EXAxisWidthChange(Sender: TObject);
    procedure EXTickMarkLengthChange(Sender: TObject);
    procedure EYAxisWidthChange(Sender: TObject);
    procedure EYTickMarkLengthChange(Sender: TObject);
    procedure XAxisColorButtonClick(Sender: TObject);
    procedure XTMColorButtonClick(Sender: TObject);
    procedure YAxisColorButtonClick(Sender: TObject);
    procedure YTMColorButtonClick(Sender: TObject);
    procedure XTMLabelFontButtonClick(Sender: TObject);
    procedure YTMLabelFontButtonClick(Sender: TObject);
    procedure EXTMLabelFormatChange(Sender: TObject);
    procedure EYTMLabelFormatChange(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    FXLabelFont, FYLabelFont : TFont;
    function VerifyFields : boolean;
    procedure EnableXLabelProperties;
    procedure EnableYLabelProperties;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetTheFields(The2DObj : TSetting2DObj);
    procedure GetTheFields(The2DObj : TSetting2DObj);
  end;

function ModifyGraph2DSettings(The2DObj : TSetting2DObj) : boolean;

implementation

{$R *.DFM}

{---------------------------------------------------------------------}

function ModifyGraph2DSettings(The2DObj : TSetting2DObj) : boolean;
var
  Settings2DDlg: TSettings2DDlg;
begin {function ModifyGraph2DSettings}
  Result := false;
  Settings2DDlg := TSettings2DDlg.Create(Application);
  try
    SetDlgDefaultPos(Settings2DDlg, nil);
    Settings2DDlg.PageControl1.ActivePageIndex := 0;
    Settings2DDlg.SetTheFields(The2DObj);
    if Settings2DDlg.ShowModal = IDOK then
      begin
        Result := true;
        Settings2DDlg.GetTheFields(The2DObj);
        The2DObj.DidFieldsChange := true;
      end { if Result = true then}
  finally
    Settings2DDlg.Free;
  end; {try..finally}
end; {function ModifyGraph2DSettings}

{---------------------------------------------------------------------}

constructor TSettings2DDlg.Create(AOwner: TComponent);
var
  I : integer;
begin {constructor TSettings2DDlg.Create}
  inherited Create(AOwner);
  FXLabelFont := CreateANewTFontClass;
  FYLabelFont := CreateANewTFontClass;
  EXTMLabelFormat.Items.Clear;
  EYTMLabelFormat.Items.Clear;
  for I := 1 to NumLabelFormatCount do
    EXTMLabelFormat.Items.Append(NumLabelFormatStrArray[I]);
  for I := 1 to NumLabelFormatCount do
    EYTMLabelFormat.Items.Append(NumLabelFormatStrArray[I]);
end; {constructor TSettings2DDlg.Create}

{---------------------------------------------------------------------}

destructor TSettings2DDlg.Destroy;
begin {destructor TSettings2DDlg.Destroy;}
  FXLabelFont.Free;
  FYLabelFont.Free;
  inherited destroy;
end; {destructor TSettings2DDlg.Destroy;}

{---------------------------------------------------------------------}

procedure TSettings2DDlg.SetTheFields(The2DObj : TSetting2DObj);
begin {procedure TSettings2DDlg.SetTheFields}
  with The2DObj do
    begin
      {X axis values}
      EXShowAxisLines.Checked := XShowAxisLines;
      EXLimitLoAxis.Text := XLimitLoAxisStr;
      //XLimitLoAxisEmpty : boolean;
      //XLimitLoAxisVal : TMathFloat;
      EXLimitHiAxis.Text := XLimitHiAxisStr;
      //XLimitHiAxisEmpty : boolean;
      //XLimitHiAxisVal : TMathFloat;
      XAxisColorSample.ColorValue := XAxisColor;
      EXAxisWidth.Position := XAxisWidth;
      case XAxisStyle of
        psSolid : XSolidPen.Down := true;
        psDash : XDashPen.Down := true;
        psDot : XDotPen.Down := true;
        psDashDot : XDashDotPen.Down := true;
        psDashDotDot : XDashDotDotPen.Down := true;
        else XSolidPen.Down := true;
      end; {case}
      case XTickMarkType of
        tmNone: EXNone.Checked := true;
        tmTickMarks: EXTickMarks.Checked := true;
        tmGridMarks: EXGridMarks.Checked := true;
        tmGridLines: EXGridLines.Checked := true;
      end; {case}
      XTMColorSample.ColorValue := XTickMarkColor;
      EXTickMarkInc.Text := XTickMarkIncStr;
      //XTickMarkIncVal : TMathFloat;
      EXTickMarkLength.Position := XTickMarkLength;
      case XGridLineStyle of
        psSolid : XGridSolidLine.Down := true;
        psDash : XGridDashLine.Down := true;
        psDot : XGridDotLine.Down := true;
        psDashDot : XGridDashDotLine.Down := true;
        psDashDotDot : XGridDashDotDotLine.Down := true;
        else XGridSolidLine.Down := true;
      end; {case}
      EXShowTMLabels.Checked := XShowTMLabels;
      EXTMLabelFormat.ItemIndex := TFloatNumFormatToCombo(XTMLabelFormat);
      EXShowTMLabelComa.Checked := XShowTMLabelComa;
      EXShowTMLabelPlus.Checked := XShowTMLabelPlus;
      EXTMLabelDecPlaces.Value := XTMLabelDecPlaces;
      {Y axis values}
      EYShowAxisLines.Checked := YShowAxisLines;
      EYLimitLoAxis.Text := YLimitLoAxisStr;
      //YLimitLoAxisEmpty : boolean;
      //YLimitLoAxisVal : TMathFloat;
      EYLimitHiAxis.Text := YLimitHiAxisStr;
      //YLimitHiAxisEmpty : boolean;
      //YLimitHiAxisVal : TMathFloat;
      YAxisColorSample.ColorValue := YAxisColor;
      EYAxisWidth.Position := YAxisWidth;
      case YAxisStyle of
        psSolid : YSolidPen.Down := true;
        psDash : YDashPen.Down := true;
        psDot : YDotPen.Down := true;
        psDashDot : YDashDotPen.Down := true;
        psDashDotDot : YDashDotDotPen.Down := true;
        else YSolidPen.Down := true;
      end; {case}
      case YTickMarkType of
        tmNone: EYNone.Checked := true;
        tmTickMarks: EYTickMarks.Checked := true;
        tmGridMarks: EYGridMarks.Checked := true;
        tmGridLines: EYGridLines.Checked := true;
      end; {case}
      YTMColorSample.ColorValue := YTickMarkColor;
      EYTickMarkInc.Text := YTickMarkIncStr;
      //YTickMarkIncVal : TMathFloat;
      EYTickMarkLength.Position := YTickMarkLength;
      case YGridLineStyle of
        psSolid : YGridSolidLine.Down := true;
        psDash : YGridDashLine.Down := true;
        psDot : YGridDotLine.Down := true;
        psDashDot : YGridDashDotLine.Down := true;
        psDashDotDot : YGridDashDotDotLine.Down := true;
        else YGridSolidLine.Down := true;
      end; {case}
      EYShowTMLabels.Checked := YShowTMLabels;
      EYTMLabelFormat.ItemIndex := TFloatNumFormatToCombo(YTMLabelFormat);
      EYShowTMLabelComa.Checked := YShowTMLabelComa;
      EYShowTMLabelPlus.Checked := YShowTMLabelPlus;
      EYTMLabelDecPlaces.Value := YTMLabelDecPlaces;
      {general values}
      BackColorSample.ColorValue := BackColor;
      {TFont values}
      FXLabelFont.Assign(XLabelFont);
      FYLabelFont.Assign(YLabelFont);
    end; {with}
  EnableXLabelProperties;
  EnableYLabelProperties;
end; {procedure TSettings2DDlg.SetTheFields}

{---------------------------------------------------------------------}

procedure TSettings2DDlg.GetTheFields(The2DObj : TSetting2DObj);
begin {procedure TSettings2DDlg.GetTheFields}
  with The2DObj do
    begin
      {X axis values}
      XShowAxisLines := EXShowAxisLines.Checked;
      XLimitLoAxisStr := EXLimitLoAxis.Text;
      XLimitLoAxisEmpty := EXLimitLoAxis.LastWasEmpty;
      XLimitLoAxisVal := EXLimitLoAxis.LastMathValue;
      XLimitHiAxisStr := EXLimitHiAxis.Text;
      XLimitHiAxisEmpty := EXLimitHiAxis.LastWasEmpty;
      XLimitHiAxisVal := EXLimitHiAxis.LastMathValue;
      XAxisColor := XAxisColorSample.ColorValue;
      XAxisWidth := EXAxisWidth.Position;
      if XSolidPen.Down then XAxisStyle := psSolid else
      if XDashPen.Down then XAxisStyle := psDash else
      if XDotPen.Down then XAxisStyle := psDot else
      if XDashDotPen.Down then XAxisStyle := psDashDot else
      if XDashDotDotPen.Down then XAxisStyle := psDashDotDot else
         XAxisStyle := psSolid;
      if EXNone.Checked then XTickMarkType := tmNone else
      if EXTickMarks.Checked then XTickMarkType := tmTickMarks else
      if EXGridMarks.Checked then XTickMarkType := tmGridMarks else
      if EXGridLines.Checked then XTickMarkType := tmGridLines else
        XTickMarkType := tmNone;
      XTickMarkColor := XTMColorSample.ColorValue;
      XTickMarkIncStr := EXTickMarkInc.Text;
      XTickMarkIncVal := EXTickMarkInc.LastMathValue;
      XTickMarkLength := EXTickMarkLength.Position;
      if XGridSolidLine.Down then XGridLineStyle := psSolid else
      if XGridDashLine.Down then XGridLineStyle := psDash else
      if XGridDotLine.Down then XGridLineStyle := psDot else
      if XGridDashDotLine.Down then XGridLineStyle := psDashDot else
      if XGridDashDotDotLine.Down then XGridLineStyle := psDashDotDot else
         XGridLineStyle := psSolid;
      XShowTMLabels := EXShowTMLabels.Checked;
      XTMLabelFormat := ComboToTFloatNumFormat(EXTMLabelFormat.ItemIndex);
      XShowTMLabelComa := EXShowTMLabelComa.Checked;
      XShowTMLabelPlus := EXShowTMLabelPlus.Checked;
      XTMLabelDecPlaces := EXTMLabelDecPlaces.Value;
      {Y axis values}
      YShowAxisLines := EYShowAxisLines.Checked;
      YLimitLoAxisStr := EYLimitLoAxis.Text;
      YLimitLoAxisEmpty := EYLimitLoAxis.LastWasEmpty;
      YLimitLoAxisVal := EYLimitLoAxis.LastMathValue;
      YLimitHiAxisStr := EYLimitHiAxis.Text;
      YLimitHiAxisEmpty := EYLimitHiAxis.LastWasEmpty;
      YLimitHiAxisVal := EYLimitHiAxis.LastMathValue;
      YAxisColor := YAxisColorSample.ColorValue;
      YAxisWidth := EYAxisWidth.Position;
      if YSolidPen.Down then YAxisStyle := psSolid else
      if YDashPen.Down then YAxisStyle := psDash else
      if YDotPen.Down then YAxisStyle := psDot else
      if YDashDotPen.Down then YAxisStyle := psDashDot else
      if YDashDotDotPen.Down then YAxisStyle := psDashDotDot else
         YAxisStyle := psSolid;
      if EYNone.Checked then YTickMarkType := tmNone else
      if EYTickMarks.Checked then YTickMarkType := tmTickMarks else
      if EYGridMarks.Checked then YTickMarkType := tmGridMarks else
      if EYGridLines.Checked then YTickMarkType := tmGridLines else
        YTickMarkType := tmNone;
      YTickMarkColor := YTMColorSample.ColorValue;
      YTickMarkIncStr := EYTickMarkInc.Text;
      YTickMarkIncVal := EYTickMarkInc.LastMathValue;
      YTickMarkLength := EYTickMarkLength.Position;
      if YGridSolidLine.Down then YGridLineStyle := psSolid else
      if YGridDashLine.Down then YGridLineStyle := psDash else
      if YGridDotLine.Down then YGridLineStyle := psDot else
      if YGridDashDotLine.Down then YGridLineStyle := psDashDot else
      if YGridDashDotDotLine.Down then YGridLineStyle := psDashDotDot else
         YGridLineStyle := psSolid;
      YShowTMLabels := EYShowTMLabels.Checked;
      YTMLabelFormat := ComboToTFloatNumFormat(EYTMLabelFormat.ItemIndex);
      YShowTMLabelComa := EYShowTMLabelComa.Checked;
      YShowTMLabelPlus := EYShowTMLabelPlus.Checked;
      YTMLabelDecPlaces := EYTMLabelDecPlaces.Value;
      {general values}
      BackColor := BackColorSample.ColorValue;
      {TFont values}
      XLabelFont.Assign(FXLabelFont);
      YLabelFont.Assign(FYLabelFont);
    end; {with}
end; {procedure TSettings2DDlg.GetTheFields}

{---------------------------------------------------------------------}

function TSettings2DDlg.VerifyFields : boolean;
begin {function TSettings2DDlg.VerifyFields}
  Result := false;
  if EXLimitLoAxis.ValidateMathStr then
  if EXLimitHiAxis.ValidateMathStr then
  if EXTickMarkInc.ValidateMathStr then
  if EYLimitLoAxis.ValidateMathStr then
  if EYLimitHiAxis.ValidateMathStr then
  if EYTickMarkInc.ValidateMathStr then
  if Validate2EditMathCtrls(EXLimitLoAxis, vct_LessOrEqual, EXLimitHiAxis, self) then
  if Validate2EditMathCtrls(EYLimitLoAxis, vct_LessOrEqual, EYLimitHiAxis, self) then
    Result := true;
end; {function TSettings2DDlg.VerifyFields}

{---------------------------------------------------------------------}

procedure TSettings2DDlg.EnableXLabelProperties;
var
  ComaCharEnabled : boolean;
  PlusSignCharEnabled : boolean;
  DecimalPlacesLabelText : string;
begin {procedure TSettings2DDlg.EnableXLabelProperties;}
  GetFloatCordDispOptions(ComboToTFloatNumFormat(EXTMLabelFormat.ItemIndex),
              ComaCharEnabled, PlusSignCharEnabled, DecimalPlacesLabelText);
  EXShowTMLabelComa.Enabled := ComaCharEnabled;
  EXShowTMLabelPlus.Enabled := PlusSignCharEnabled;
  TextFieldXTMLabelDP.Caption := DecimalPlacesLabelText;
end; {procedure TSettings2DDlg.EnableXLabelProperties;}

{---------------------------------------------------------------------}

procedure TSettings2DDlg.EnableYLabelProperties;
var
  ComaCharEnabled : boolean;
  PlusSignCharEnabled : boolean;
  DecimalPlacesLabelText : string;
begin {procedure TSettings2DDlg.EnableYLabelProperties;}
  GetFloatCordDispOptions(ComboToTFloatNumFormat(EYTMLabelFormat.ItemIndex),
              ComaCharEnabled, PlusSignCharEnabled, DecimalPlacesLabelText);
  EYShowTMLabelComa.Enabled := ComaCharEnabled;
  EYShowTMLabelPlus.Enabled := PlusSignCharEnabled;
  TextFieldYTMLabelDP.Caption := DecimalPlacesLabelText;
end; {procedure TSettings2DDlg.EnableYLabelProperties;}

{---------------------------------------------------------------------}

procedure TSettings2DDlg.BackColorButtonClick(Sender: TObject);
begin
  BackColorSample.ColorValue := ReturnNewColorComnDlg(BackColorSample.ColorValue, Self);
end;

procedure TSettings2DDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := true;
  if ModalResult = IDOK then
    begin
      CanClose := VerifyFields;
    end; {if}
end;

procedure TSettings2DDlg.EXAxisWidthChange(Sender: TObject);
begin
  XAxisWidthLabel.caption := IntToStr(EXAxisWidth.Position);
end;

procedure TSettings2DDlg.EXTickMarkLengthChange(Sender: TObject);
begin
  XTMSizeLabel.caption := IntToStr(EXTickMarkLength.Position);
end;

procedure TSettings2DDlg.EYAxisWidthChange(Sender: TObject);
begin
  YAxisWidthLabel.caption := IntToStr(EYAxisWidth.Position);
end;

procedure TSettings2DDlg.EYTickMarkLengthChange(Sender: TObject);
begin
  YTMSizeLabel.caption := IntToStr(EYTickMarkLength.Position);
end;

procedure TSettings2DDlg.XAxisColorButtonClick(Sender: TObject);
begin
  XAxisColorSample.ColorValue := ReturnNewColorComnDlg(XAxisColorSample.ColorValue, Self);
end;

procedure TSettings2DDlg.XTMColorButtonClick(Sender: TObject);
begin
  XTMColorSample.ColorValue := ReturnNewColorComnDlg(XTMColorSample.ColorValue, Self);
end;

procedure TSettings2DDlg.YAxisColorButtonClick(Sender: TObject);
begin
  YAxisColorSample.ColorValue := ReturnNewColorComnDlg(YAxisColorSample.ColorValue, Self);
end;

procedure TSettings2DDlg.YTMColorButtonClick(Sender: TObject);
begin
  YTMColorSample.ColorValue := ReturnNewColorComnDlg(YTMColorSample.ColorValue, Self);
end;

procedure TSettings2DDlg.XTMLabelFontButtonClick(Sender: TObject);
begin
  ShowComnFontDlg(FXLabelFont, Self);
end;

procedure TSettings2DDlg.YTMLabelFontButtonClick(Sender: TObject);
begin
  ShowComnFontDlg(FYLabelFont, Self);
end;

procedure TSettings2DDlg.EXTMLabelFormatChange(Sender: TObject);
begin
  EnableXLabelProperties;
  EXTMLabelDecPlaces.Value := GetFloatCordDecPlacesDefault(
                     ComboToTFloatNumFormat(EXTMLabelFormat.ItemIndex));
end;

procedure TSettings2DDlg.EYTMLabelFormatChange(Sender: TObject);
begin
  EnableYLabelProperties;
  EYTMLabelDecPlaces.Value := GetFloatCordDecPlacesDefault(
                     ComboToTFloatNumFormat(EYTMLabelFormat.ItemIndex));
end;

procedure TSettings2DDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
  FormKeyPressSpinEditClose(self, Key);
end;

end.
