unit Selctdlg;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, Dialogs, CentrDlg, GrDraw;

type
  TSelectedRegionDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    TopLeftBox: TGroupBox;
    BottomRightBox: TGroupBox;
    ETopX: TSpinEdit;
    ETopY: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    EBottomX: TSpinEdit;
    EBottomY: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function ModifySelectedRegionDlg(IsRegionSelected : boolean;
                    var SelectOrigin, SelectMovePt : TPoint;
                    BmpWidth, BmpHeight : integer) : boolean;

implementation

{$R *.DFM}

function ModifySelectedRegionDlg(IsRegionSelected : boolean;
                    var SelectOrigin, SelectMovePt : TPoint;
                    BmpWidth, BmpHeight : integer) : boolean;
var
  SelectedRegionDlg: TSelectedRegionDlg;
begin {function ModifySelectedRegionDlg}
  Result := false;
  SelectedRegionDlg := TSelectedRegionDlg.Create(Application);
  try
   SetDlgDefaultPos(SelectedRegionDlg, nil);
    with SelectedRegionDlg do
      begin
        ETopX.MaxValue := BmpWidth - 1;
        ETopY.MaxValue := BmpHeight - 1;
        EBottomX.MaxValue := BmpWidth - 1;
        EBottomY.MaxValue := BmpHeight - 1;
      end; {with}
    if IsRegionSelected then
      begin
        with SelectedRegionDlg do
          begin
            ETopX.Value := SelectOrigin.X;
            ETopY.Value := SelectOrigin.Y;
            EBottomX.Value := SelectMovePt.X;
            EBottomY.Value := SelectMovePt.Y;
          end; {with}
      end; {if}
    if SelectedRegionDlg.ShowModal = IDOK then
      begin
        Result := true;
        with SelectedRegionDlg do
          begin
            SelectOrigin.X := ETopX.Value;
            SelectOrigin.Y := ETopY.Value;
            SelectMovePt.X := EBottomX.Value;
            SelectMovePt.Y := EBottomY.Value;
          end; {with}
      end; {if}
  finally
    SelectedRegionDlg.free;
  end; {try..finally}
end; {function ModifySelectedRegionDlg}

procedure TSelectedRegionDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := true;
  if ModalResult = IDOK then
    begin
      if not((ETopX.Value < EBottomX.Value)and
             (ETopY.Value < EBottomY.Value)and
        (abs(ETopX.Value - EBottomX.Value) >= MinSelectRegionSize)and
        (abs(ETopY.Value - EBottomY.Value) >= MinSelectRegionSize))then
        begin
          CanClose := false;
          MessageDlgCenter('The Bottom Right (X,Y) must be at least '+
             MinSelectRegionSizeStr+' greater than the Top Left (X,Y).',
             mtError, [mbOk], 0, Self);
        end; {if}
    end; {if}
end;

procedure TSelectedRegionDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
  FormKeyPressSpinEditClose(self, Key);
end;

end.
