unit Vw3dDlg;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysutils, Dialogs, FloatStr, CentrDlg,
  MathCalc, MathFunc, editmath, Vw3dObj;

type
  TChange3DViewDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox2: TGroupBox;
    EViewZoom: TSpinEdit;
    Label1: TLabel;
    ERotateX: TEditMathConst;
    ERotateY: TEditMathConst;
    ERotateZ: TEditMathConst;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetTheFields(View3DZoomObj : TView3DZoomObj);
    procedure SetTheFields(View3DZoomObj : TView3DZoomObj);
  end;

function ModifyView3D(View3DZoomObj : TView3DZoomObj) : boolean;

implementation

{$R *.DFM}

{---------------------------------------------------------------------}

function ModifyView3D(View3DZoomObj : TView3DZoomObj) : boolean;
var
  Change3DViewDlg: TChange3DViewDlg;
begin {function ModifyView3D}
  Result := false;
  Change3DViewDlg := TChange3DViewDlg.Create(Application);
  try
    SetDlgDefaultPos(Change3DViewDlg, nil);
    Change3DViewDlg.SetTheFields(View3DZoomObj);
    if Change3DViewDlg.ShowModal = IDOK then
      begin
        Result := true;
        Change3DViewDlg.GetTheFields(View3DZoomObj);
        View3DZoomObj.DidFieldsChange := true;
      end { if Result = true then}
  finally
    Change3DViewDlg.Free;
  end; {try..finally}
end; {function ModifyView3D}

{---------------------------------------------------------------------}

procedure TChange3DViewDlg.GetTheFields(View3DZoomObj : TView3DZoomObj);
begin {procedure TChange3DViewDlg.GetTheFields}
  with View3DZoomObj do
    begin
      RotateX := RotateNumTo360D(ERotateX.LastValue);
      RotateY := RotateNumTo360D(ERotateY.LastValue);
      RotateZ := RotateNumTo360D(ERotateZ.LastValue);
      ViewZoom := EViewZoom.Value;
    end; {with}
end; {procedure TChange3DViewDlg.GetTheFields}

{---------------------------------------------------------------------}

procedure TChange3DViewDlg.SetTheFields(View3DZoomObj : TView3DZoomObj);
begin {procedure TChange3DViewDlg.SetTheFields}
  with View3DZoomObj do
    begin
      ERotateX.Text := RotateNumToStr(RotateX);
      ERotateY.Text := RotateNumToStr(RotateY);
      ERotateZ.Text := RotateNumToStr(RotateZ);
      EViewZoom.Value := ViewZoom;
    end; {with}
end; {procedure TChange3DViewDlg.SetTheFields}

{---------------------------------------------------------------------}

procedure TChange3DViewDlg.FormCloseQuery(Sender: TObject;
                                          var CanClose: Boolean);
begin
  if ModalResult <> IDOK then
    CanClose := true
  else
    begin
      CanClose := false;
      if ERotateX.ValidateMathStr then
        if ERotateY.ValidateMathStr then
          if ERotateZ.ValidateMathStr then
            CanClose := true;
    end; {else}
end;

{---------------------------------------------------------------------}

procedure TChange3DViewDlg.FormKeyPress(Sender: TObject; var Key: Char);
begin
  FormKeyPressSpinEditClose(Self, Key);
end;

{---------------------------------------------------------------------}

end.
