unit WindPolr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WinGraph, Menus, ImagPolr, funcpolr, DgGlobal, CentrDlg, VwPoDlg,
  Flistdlg, MathCalc, VwPoObj, SetPoDlg;

type
  TWindowPolar = class(TWindowGraph)
    Function1: TMenuItem;
    GraphSettings2: TMenuItem;
    N1: TMenuItem;
    NewPolarFunction1: TMenuItem;
    N2: TMenuItem;
    EditFunctionList1: TMenuItem;
    View1: TMenuItem;
    ChangeView1: TMenuItem;
    N3: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    N4: TMenuItem;
    ScrollViewUp1: TMenuItem;
    ScrollViewDown1: TMenuItem;
    ScrollViewLeft1: TMenuItem;
    ScrollViewRight1: TMenuItem;
    N5: TMenuItem;
    PageViewUp1: TMenuItem;
    PageViewDown1: TMenuItem;
    PageViewLeft1: TMenuItem;
    PageViewRight1: TMenuItem;
    N6: TMenuItem;
    CenterFunctionView1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure GraphSettings2Click(Sender: TObject);
    procedure NewPolarFunction1Click(Sender: TObject);
    procedure EditFunctionList1Click(Sender: TObject);
    procedure ChangeView1Click(Sender: TObject);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);
    procedure ScrollViewUp1Click(Sender: TObject);
    procedure ScrollViewDown1Click(Sender: TObject);
    procedure ScrollViewLeft1Click(Sender: TObject);
    procedure ScrollViewRight1Click(Sender: TObject);
    procedure PageViewUp1Click(Sender: TObject);
    procedure PageViewDown1Click(Sender: TObject);
    procedure PageViewLeft1Click(Sender: TObject);
    procedure PageViewRight1Click(Sender: TObject);
    procedure CenterFunctionView1Click(Sender: TObject);
  private
    { Private declarations }
    FImagePolar : TImagePolar;
  protected
    { Protected declarations }
    procedure SendWinActivateMessage; override;
  public
    { Public declarations }
    procedure ZoomIn; override;
    procedure ZoomOut; override;
    procedure CenterFunctionView; override;
    procedure PageViewUp;
    procedure PageViewDown;
    procedure PageViewLeft;
    procedure PageViewRight;
    procedure ScrollViewUp;
    procedure ScrollViewDown;
    procedure ScrollViewLeft;
    procedure ScrollViewRight;
    procedure ChangeView;
    function ChangeGraphSettings : boolean;
    function AddPolarFunction : boolean;
    function ModifyFunctionList : boolean;
    procedure DisplayStatusMessage; override;
  end; {TWindowPolar}

{var
  WindowPolar: TWindowPolar;}

implementation

{$R *.dfm}

uses
  FSMain;

{ TWindowPolar }

procedure TWindowPolar.SendWinActivateMessage;
begin
  MainForm.GraphPolarActivateMessage;
end;

procedure TWindowPolar.FormCreate(Sender: TObject);
begin
  inherited;
  FImagePolar := TImagePolar.Create(Self);
  SetPlotImageBox(FImagePolar);
end;

function TWindowPolar.AddPolarFunction: boolean;
var
  FuncPolarObj : TFuncPolarObj;
begin
  Result := false;
  if FImagePolar.IsFreeFuncListObjSlot then
    begin
      FuncPolarObj := TFuncPolarObj.Create;
      if NewUserFunctionObj(FuncPolarObj, FImagePolar.GetNextDefaultColor, nil) then
        begin
          FImagePolar.AddNewFuncListObj(FuncPolarObj);
          Result := true;
        end
      else
        FuncPolarObj.Free;
    end
  else
    begin
      MessageDlgOverMaxFuncCount(MaxPolarFuncCount);
    end; {else}
end;

procedure TWindowPolar.CenterFunctionView;
begin
  with FImagePolar.ViewPolarZoomObj do
    begin
      if (ViewCenterX <> 0) or (ViewCenterY <> 0) then
        begin
          ViewCenterX := 0;
          ViewCenterY := 0;
          DidFieldsChange := true;
          FImagePolar.RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.ChangeView;
begin
  with FImagePolar do
    if ModifyViewPolar(ViewPolarZoomObj) then
      RestartFieldObjectChanged;
end;

procedure TWindowPolar.DisplayStatusMessage;
begin
  with FImagePolar do
    MainForm.StatusLineObj.UpDatePolarStatusLine(ViewPolarZoomObj,
        SettingBmpAttribsObj.BmpWidth, SettingBmpAttribsObj.BmpHeight,
        LastMouseX, LastMouseY);
end;

function TWindowPolar.ModifyFunctionList: boolean;
var
  DidModify,
  DidDelete,
  DidReOrder : boolean;
begin
  DisplayFuncListDlg(FImagePolar.FuncList, DidModify, DidDelete, DidReOrder);
  Result := (DidModify or DidDelete or DidReOrder);
end;

procedure TWindowPolar.PageViewDown;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterY-(SettingBmpAttribsObj.BMPHeight div 2);
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterY <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterY := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.PageViewLeft;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterX-(SettingBmpAttribsObj.BMPWidth div 2);
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterX <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterX := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.PageViewRight;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterX+(SettingBmpAttribsObj.BMPWidth div 2);
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterX <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterX := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.PageViewUp;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterY+(SettingBmpAttribsObj.BMPHeight div 2);
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterY <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterY := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.ScrollViewDown;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterY - MainForm.HotKeyPolarObj.GraphScrollViewAmount;
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterY <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterY := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.ScrollViewLeft;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterX - MainForm.HotKeyPolarObj.GraphScrollViewAmount;
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterX <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterX := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {iwth}
end;

procedure TWindowPolar.ScrollViewRight;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterX + MainForm.HotKeyPolarObj.GraphScrollViewAmount;
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterX <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterX := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.ScrollViewUp;
var
  Tmp : TMathFloat;
begin
  with FImagePolar do
    begin
      Tmp := ViewPolarZoomObj.ViewCenterY + MainForm.HotKeyPolarObj.GraphScrollViewAmount;
      if Tmp > MaxPolarViewCenter then
        Tmp := MaxPolarViewCenter;
      if Tmp < MinPolarViewCenter then
        Tmp := MinPolarViewCenter;
      if ViewPolarZoomObj.ViewCenterY <> Tmp then
        begin
          ViewPolarZoomObj.ViewCenterY := Tmp;
          ViewPolarZoomObj.DidFieldsChange := true;
          RestartFieldObjectChanged;
        end; {if}
    end; {with}
end;

procedure TWindowPolar.ZoomIn;
begin
  with FImagePolar do
    if MainForm.HotKeyPolarObj.CalcPolarZoomIn(ViewPolarZoomObj.ViewZoom) then
      begin
        ViewPolarZoomObj.DidFieldsChange := true;
        RestartFieldObjectChanged;
      end; {if}
end;

procedure TWindowPolar.ZoomOut;
begin
  with FImagePolar do
    if MainForm.HotKeyPolarObj.CalcPolarZoomOut(ViewPolarZoomObj.ViewZoom) then
      begin
        ViewPolarZoomObj.DidFieldsChange := true;
        RestartFieldObjectChanged;
      end; {if}
end;

procedure TWindowPolar.GraphSettings2Click(Sender: TObject);
begin
  if ChangeGraphSettings then
    FImagePolar.RestartFieldObjectChanged;
end;

procedure TWindowPolar.NewPolarFunction1Click(Sender: TObject);
begin
  if AddPolarFunction then
    FImagePolar.RestartFieldObjectChanged;
end;

procedure TWindowPolar.EditFunctionList1Click(Sender: TObject);
begin
  if ModifyFunctionList then
    FImagePolar.RestartFieldObjectChanged;
end;

procedure TWindowPolar.ChangeView1Click(Sender: TObject);
begin
  ChangeView;
end;

procedure TWindowPolar.ZoomIn1Click(Sender: TObject);
begin
  ZoomIn;
end;

procedure TWindowPolar.ZoomOut1Click(Sender: TObject);
begin
  ZoomOut;
end;

procedure TWindowPolar.ScrollViewUp1Click(Sender: TObject);
begin
  ScrollViewUp;
end;

procedure TWindowPolar.ScrollViewDown1Click(Sender: TObject);
begin
  ScrollViewDown;
end;

procedure TWindowPolar.ScrollViewLeft1Click(Sender: TObject);
begin
  ScrollViewLeft;
end;

procedure TWindowPolar.ScrollViewRight1Click(Sender: TObject);
begin
  ScrollViewRight;
end;

procedure TWindowPolar.PageViewUp1Click(Sender: TObject);
begin
  PageViewUp;
end;

procedure TWindowPolar.PageViewDown1Click(Sender: TObject);
begin
  PageViewDown;
end;

procedure TWindowPolar.PageViewLeft1Click(Sender: TObject);
begin
  PageViewLeft;
end;

procedure TWindowPolar.PageViewRight1Click(Sender: TObject);
begin
  PageViewRight;
end;

procedure TWindowPolar.CenterFunctionView1Click(Sender: TObject);
begin
  CenterFunctionView;
end;

function TWindowPolar.ChangeGraphSettings: boolean;
begin
  Result := ModifyGraphPolarSettings(FImagePolar.SettingPolarObj);
end;

end.
