unit readedit;

(*
Copyright 1999-2011 Greg VanMullem
This program is distributed under the terms of the GNU General Public License Version 3

This file is part of MathGV.

MathGV is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

MathGV is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MathGV.  If not, see <http://www.gnu.org/licenses/>.
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, CentrDlg;

type
  TEditStrReadErrorDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    ErrorTextLabel: TLabel;
    EditString: TEdit;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{var
  EditStrReadErrorDlg: TEditStrReadErrorDlg;}

function ShowEditStrReadErrorDlg(const TheErrorString : string; var TheEditString : string): boolean;

implementation

{$R *.DFM}

function ShowEditStrReadErrorDlg(const TheErrorString : string; var TheEditString : string): boolean;
var
  EditStrReadErrorDlg: TEditStrReadErrorDlg;
begin {function ShowEditStrReadErrorDlg}
  EditStrReadErrorDlg := TEditStrReadErrorDlg.Create(Application);
  try
    SetDlgDefaultPos(EditStrReadErrorDlg, nil);
    EditStrReadErrorDlg.ErrorTextLabel.Caption := TheErrorString;
    EditStrReadErrorDlg.EditString.text := TheEditString;
    Result := (EditStrReadErrorDlg.ShowModal = IDOK);
    if Result then
      begin
        TheEditString := EditStrReadErrorDlg.EditString.text;
      end; {if}
  finally
    EditStrReadErrorDlg.Free;
  end; {try..finally}
end; {function ShowEditStrReadErrorDlg}

end.
